/*
FileName:AdminTimeSheet.js
Version:1.0.0
Purpose:Working Hours showing in table formate
Devloper:Mahesh,Santhosh
*/
import React, { Component } from 'react';
import {
    Platform, StyleSheet, TextPropTypes, Picker, Text, Button, View, Image, StatusBar, Dimensions, TextInput, Alert,
    KeyboardAvoidingView,
    TouchableWithoutFeedback,
    FlatList,
    Keyboard
} from 'react-native';
// import { Chart, VerticalAxis, HorizontalAxis, Line } from 'react-native-responsive-linechart'
import { Icon, Title, Container, Content, Header, Right, Left, Body } from 'native-base';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import { TouchableOpacity } from 'react-native-gesture-handler';
import AsyncStorage from '@react-native-community/async-storage';
import { ReportsAPI } from "../WebServices/RestClient";
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import log from '../LogFile/Log';
import ProffileOffline from '../OfflineDB/Profile';
const db = new ProffileOffline();
import Main from '../Maintenance/Main';
import jwt_decode from "jwt-decode";
import ModalSelector from 'react-native-modal-selector';
const check = new Main()
import {
    DotIndicator,
} from 'react-native-indicators';
// import { LineChart, BarChart } from "react-native-chart-kit";
import { ScrollView } from 'react-native-gesture-handler';
import { PROFILE, CHANGEPASSWORD, EMPLOYEEID, USERNAME, EMAIL, MOBILE, FULLNAME1, DESIGNATION, TEAM, ROLE, FMANAGER, RMANAGER, STATUS1 } from '../CommonComponents/Header';
import SearchableDropdown from 'react-native-searchable-dropdown';
import PureChart from 'react-native-pure-chart';
import moment from "moment";
import DateRangePicker from "react-native-daterange-picker";
import { DataTable } from 'react-native-paper';

class ListItem extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            isLoading: true,
            // roledata: '',
        }

    }


    render() {
        const { item } = this.props;
        // alert("Setting")
        AsyncStorage.getItem("emp_role", (err, res) => {
            this.setState({
                roledata: res
            })

        });


        return (
            <View style={styles.container}>

                <View style={{ flexDirection: 'row' }}>
                    <View style={{ flexDirection: 'row', width: 140, borderWidth: 1, borderColor: 'black' }}>
                        <Text style={{}} >{item.story_title}</Text>
                    </View>

                    <View style={{ flexDirection: 'row', }}>
                        <View style={{ flexDirection: 'row', borderWidth: 1, borderColor: 'black' }}>
                            <Text style={{ width: 80 }} >  {item.working_hours}  </Text>
                        </View>


                    </View>
                </View>

            </View>

        )
    }
}

export default class AdminTimeSheet extends Component {

    constructor(props) {
        super(props);

        this.state = {
            isLoading: false,
            isVisibleB: false,
            sprintName: 'Select User',
            epicName: 'Select Epic',
            resource: [],
            resource1: [],
            dataSource: [],
            // startDate: null,
            // endDate: null,
            displayedDate: moment(),
            startDate: moment().set("date", -15),
            endDate: moment().set("date", 15),
            selectedDays: [],
            selectedWeeks: [],
            select: ''
        }

        AsyncStorage.getItem("cropcode", (err, res) => {
            this.setState({ squadName: res });
            console.warn("squadname" + this.state.squadName);
        });

    }

    setDates = (dates) => {
        this.setState({
            ...dates,
        });
    };


    getDates = (startDate, stopDate) => {
        var dateArray = [];
        var currentDate = moment(startDate);
        stopDate = moment(stopDate);
        while (currentDate <= stopDate) {
            dateArray.push(moment(currentDate).format('MM-DD-YYYY'))
            currentDate = moment(currentDate).add(1, 'days');
        }
        return dateArray;
    }
    getWeeks = (startDate, stopDate) => {
        var dateArray = [];
        var currentDate = moment(startDate);
        stopDate = moment(stopDate);
        while (currentDate <= stopDate) {
            dateArray.push(moment(currentDate).format('dddd'))
            currentDate = moment(currentDate).add(1, 'days');
        }
        return dateArray;
    }




    componentDidMount() {
        //this.getUsers();
        this.getEmployees();
        this.getModules();
        // this.GetStatus();
        // this.Reports();
    }


    //getting the Employees list for addind maintask
    getEmployees() {
        log("Info", " getEmployees(cropcode) is used for getting the Employees list for addind maintask");
        const { ModuleId } = this.state;
        const { ideaid } = this.state;
        // console.warn("ModuleId"+ModuleId)

        AsyncStorage.getItem("cropcode", (err, res) => {
            const cropcode = res;
            AsyncStorage.getItem("projectId", (err, res) => {
                const projectId = res;
                NetInfo.fetch().then(state => {
                    if (state.type == "none") {
                        console.log(state.type);
                        log("Warn", "No internet connection");
                        Snackbar.show({
                            title: 'No Internet Connection',
                            backgroundColor: 'red',
                            duration: Snackbar.LENGTH_LONG,
                        });
                    } else {
                        fetch(API + 'get_user.php',
                            {
                                method: 'POST',
                                headers: {
                                    Accept: 'application/json',
                                    'Content-Type': 'application/json',
                                },
                                body: JSON.stringify({
                                    corp: cropcode,
                                    projectId: projectId,
                                    action: "get_squads_list"
                                })
                            })
                            .then((response) => response.json())
                            .then((responseJson) => {
                                if (responseJson.status === 'True') {
                                    //alert("Employees" + JSON.stringify(responseJson))
                                    var epicsList = [];
                                    responseJson.data.map((epics) => {
                                        return (

                                            epicsList.push({
                                                'id': epics.id, 'name': epics.name
                                            })
                                        );
                                    })

                                    this.setState({
                                        resource1: epicsList,
                                    });
                                }
                            })
                            .catch((error) => {
                                console.error(error);
                                log("Error", "requested projects error");
                            });
                    }
                });
            });
        });
    }

    // //getting the Employees list for addind maintask

    // getUsers() {

    //     // const { extension, username} = this.state;

    //     // const [username, extension] = (username).split('@')
    //     NetInfo.fetch().then(state => {
    //         if (state.type == "none") {
    //             Snackbar.show({
    //                 title: 'No Internet Connection',
    //                 backgroundColor: 'red',
    //                 duration: Snackbar.LENGTH_LONG,
    //             });
    //         } else {

    //             fetch(API + 'get_user.php', {
    //                 method: 'GET',
    //                 headers: {
    //                     'Accept': 'application/json',
    //                     'Content-Type': 'application/json',
    //                 },
    //                 body: JSON.stringify({
    //                     action: "get_squads_list",
    //                     username: username,
    //                     extension: extension,
    //                     // corp: cropcode,
    //                     // projectId: projectId,
    //                 })

    //             }).then((response) => response.json())
    //                 .then((responseJson) => {
    //                     alert("users" + JSON.stringify(responseJson))

    //                     var sprintList = [];
    //                     responseJson.map((sprints) => {
    //                         return (
    //                             sprintList.push({
    //                                 'id': sprints.emp_id, 'name': sprints.fullname
    //                             })
    //                         );
    //                     })

    //                     this.setState({
    //                         resource1: sprintList
    //                     },
    //                         function () {

    //                         }
    //                     );

    //                 }).catch((error) => {
    //                     check.Maintenance();
    //                     console.error(error);
    //                     log("Error", "Error in getting profile data");

    //                 });
    //         }


    //     });
    // }


    //get Module list start
    getModules() {

        const { idea_id } = this.state;

        console.log(idea_id);

        AsyncStorage.getItem("cropcode", (err, res) => {

            const cropcode = res;
            AsyncStorage.getItem("emp_role", (err, res) => {

                AsyncStorage.getItem("projectId", (err, res) => {
                    const projectId = res;
                    const role = res;
                    AsyncStorage.getItem("userToken", (err, res) => {
                        const empId = res;
                        NetInfo.fetch().then(state => {
                            if (state.type == "none") {
                                console.log(state.type);
                                log("Warn", "No internet connection");
                                Snackbar.show({
                                    title: 'No Internet Connection',
                                    backgroundColor: 'red',
                                    duration: Snackbar.LENGTH_LONG,
                                });
                            } else {
                                fetch(API + 'get_timesheets.php',
                                    {
                                        method: 'POST',
                                        headers: {
                                            Accept: 'application/json',
                                            'Content-Type': 'application/json',
                                        },
                                        body: JSON.stringify({
                                            // action: 'getCompletedSprints',
                                            // empId: empId,
                                            // userType: role,
                                            // idea_id: idea_id,
                                            // crop: cropcode,
                                            // projectId:projectId,
                                        })
                                    })
                                    .then((response) => response.json())
                                    .then((responseJson) => {
                                        //  alert(JSON.stringify(responseJson));
                                        // alert("Hello" + JSON.stringify(responseJson))
                                        // console.warn("Hello"+typeof(100.00));
                                        // console.warn(Number(100.00));
                                        if (responseJson.status === 'True') {
                                            // this.addArchivesList(responseJson.data, cropcode) //Store Approved Projects List Offline

                                            this.setState({
                                                isLoading: false,
                                                dataSource: responseJson.data,
                                                isFetching: false
                                            }, function () {

                                            });
                                            this.arrayholder = responseJson.data;
                                        }

                                        else {
                                            this.arrayholder = [];
                                            this.setState({
                                                isLoading: false,
                                                dataSource: [],
                                            })
                                            Snackbar.show({
                                                title: 'No Sprints',
                                                backgroundColor: '#3BB9FF',
                                                duration: Snackbar.LENGTH_LONG,
                                            });
                                        }
                                    })

                                    .catch((error) => {
                                        this.setState({
                                            isLoading: false,
                                        })
                                        console.error(error);
                                        log("Error", "Add Module error");
                                    });
                            }
                        });
                    });
                });
            });
        });
    }




    render() {
        const { assignedto, sprintName, startDate, endDate, displayedDate } = this.state;

        const data = {
            "selectedOption":
            {
                "value": assignedto,
                "label": sprintName
            }
        }

        //alert(JSON.stringify(data));
        //alert(JSON.stringify(this.state.startDate));

        // alert("Employee "+this.state.resource1+"test")
        var filter = [{
            "startDate": moment(this.state.startDate).format('YYYY-MM-DD'),
            "endDate": moment(this.state.endDate).format('YYYY-MM-DD'),
            // "key": "selection"
        }]
        //alert(JSON.stringify(filter));
        // const { startDate, endDate, displayedDate, minDate, maxDate } = this.state;
        // alert("data "+this.state.dataSource+"test")
        var getTotalHours = () => {

            let working_hours = 0;
            // eslint-disable-next-line
            const rowTotals = this.state.dataSource.filter((val) => {


                if (this.state.assignedto === '' && (Date.parse(val.updated_date) >= Date.parse(moment(filter[0].startDate).format('YYYY-MM-DD')) && Date.parse(val.updated_date) <= Date.parse(moment(filter[0].endDate).format('YYYY-MM-DD')))) {
                    return val
                }

                else if (val.assigned_to.includes(this.state.assignedto) && (Date.parse(val.updated_date) >= Date.parse(moment(filter[0].startDate).format('YYYY-MM-DD')) && Date.parse(val.updated_date) <= Date.parse(moment(filter[0].endDate).format('YYYY-MM-DD')))) {
                    return val
                }
            }).map(
                row => (row.working_hours) || 0
            )
            if (rowTotals.length > 0) {
                working_hours = rowTotals.reduce((acc, val1) =>
                    parseFloat(acc) + parseFloat(val1)
                );
            }
            return Math.round(working_hours);
        }



        if (this.state.isLoading) {
            return (
                <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
                    <DotIndicator color='#00A2C1' />
                </View>
            );

        }

        return (
            // <KeyboardAvoidingView
            //     style={{ flex: 1 }}
            //     behavior={Platform.OS === "ios" ? "padding" : "height"}
            // >
                <Container>

                    <Header
                        androidStatusBarColor="#00A2C1"
                        style={{
                            backgroundColor: '#00A2C1',
                            height: 60,
                            width: Dimensions.get('window').width,
                            borderBottomColor: '#ffffff',
                            justifyContent: 'space-between',
                        }}>
                        <View style={{ marginTop: 20 }}>
                            <Icon name="md-menu" size={25} style={{ color: 'white', }} onPress={() =>
                                this.props.navigation.toggleDrawer()} />
                        </View>

                        <View style={{ width: 300, borderRadius: 20, height: 45, marginTop: 5, flexDirection: 'row' }}>

                            <Text style={{ width: 300, borderRadius: 20, height: 45, marginTop: 20, flexDirection: 'row', color: 'white' }}>AdminTimeSheet</Text>



                        </View>

                    </Header>
                    {/* <Content> */}






                    



                            <View style={{ paddingTop: 20, flexDirection: 'row', }}>
                                <SearchableDropdown
                                    placeholder={this.state.sprintName}
                                    onTextChange={text => console.log(text)}
                                    onItemSelect={(item) => this.setState({ assignedto: item.id, sprintName: item.name })}
                                    placeholderTextColor='black'
                                    containerStyle={{
                                        paddingLeft: "2%",
                                        width: '70%',
                                        height: 150

                                    }}
                                    placeholderTextColor='black'
                                    textInputStyle={{
                                        padding: 12,
                                        borderWidth: 1,
                                        borderColor: '#ccc',
                                        backgroundColor: '#fff',
                                        borderRadius: 20
                                    }}
                                    itemStyle={{
                                        padding: 10,
                                        marginTop: 2,
                                        backgroundColor: '#FAF9F8',
                                        borderColor: '#bbb',
                                        borderWidth: 1,
                                        borderRadius: 20
                                    }}
                                    itemTextStyle={{
                                        color: '#222',
                                    }}
                                    items={this.state.resource1}
                                    defaultIndex={2}
                                    resetValue={false}
                                    underlineColorAndroid="transparent"
                                />
                                <Text style={{ color: 'red' }}>{this.state.error3}</Text>

                                <DateRangePicker
                                    style={{ zIndex: -100, position: 'absolute', }}
                                    onChange={this.setDates}
                                    startDate={startDate}
                                    endDate={endDate}

                                    presetButtons={true}
                                    completed
                                    range
                                    displayedDate={displayedDate}
                                    moment={moment}
                                >
                                    <Image style={{ width: wp('8%'), height: hp('4%'), margin: 5 }} source={require('../Images/calender.jpeg')} />

                                </DateRangePicker>
                                {/*  <TouchableOpacity style={styles.opensave} onPress={() => { this.getModules() }}>
                                        <Text style={{ color: 'white', padding: 5 }}>Show</Text>
                                    </TouchableOpacity> */}
                            </View>




                 


                        {/* 
                        <View style={{ flexDirection: 'row', marginLeft: 17 }}>
                            <View style={{ flexDirection: 'row', width: 140, borderWidth: 1, borderColor: 'black', }}>
                                <Text style={styles.signUpText0} >USER STORY</Text>
                            </View>


                            <View style={{ flexDirection: 'row', }}>
                                <View style={{ flexDirection: 'row', borderWidth: 1, borderColor: 'black' }}>
                                    <Text style={styles.signUpText0} >  Completed  </Text>
                                </View>
                            </View>
                        </View>

                        <FlatList

                            extraData={this.state}
                            keyExtractor={this._keyExtractor}
                            renderItem={this._renderItem}

                            data={this.state.dataSource}

                            refreshing={this.state.isFetching}

                            ItemSeparatorComponent={this.FlatListItemSeparator}
                            renderItem={({ item, index }) =>
                                <View>

                                    <ListItem navigation={this.props.navigation}
                                        item={item}
                                        ReOpenProjectAction={() => this.ReOpenProjectAction(item, index)}//For ReOpen Project
                                    />
                                </View>
                            }
                            keyExtractor={item => item.id}
                            ListEmptyComponent={this._listEmptyComponent}
                        /> */}
                          <ScrollView horizontal style={{height:'40%',marginTop:100 }}>
                        <View>
                       
                        <DataTable>
                            <DataTable.Header style={{ backgroundColor: '#333f50', color: "white" }}>
                                <DataTable.Title style={{width:200}}><Text style={{ color: "white" }}>User Story</Text></DataTable.Title>
                                <DataTable.Title style={{width:150}}><Text style={{ color: "white" }}>Working Hours</Text></DataTable.Title>
                                <DataTable.Title style={{width:50}}><Text style={{ color: "white" }}>Day</Text></DataTable.Title>
                                <DataTable.Title style={{width:100}}><Text style={{ color: "white" }}>Date</Text></DataTable.Title>
                                <DataTable.Title style={{width:150}}><Text style={{ color: "white" }}>Emp Name</Text></DataTable.Title>

                            </DataTable.Header>
                        </DataTable>
                        {this.state.dataSource.length > 0 ? this.state.dataSource.filter((val) => {

                            if (this.state.assignedto === '' && (Date.parse(val.updated_date) >= Date.parse(moment(filter[0].startDate).format('YYYY-MM-DD')) && Date.parse(val.updated_date) <= Date.parse(moment(filter[0].endDate).format('YYYY-MM-DD')))) {
                                return val
                            }

                            else if (val.assigned_to.includes(this.state.assignedto) && (Date.parse(val.updated_date) >= Date.parse(moment(filter[0].startDate).format('YYYY-MM-DD')) && Date.parse(val.updated_date) <= Date.parse(moment(filter[0].endDate).format('YYYY-MM-DD')))) {
                                return val
                            }

                        })
                            .map((item, key) => {
                                return (
                                    <DataTable>
                                        <DataTable.Row style={{ marginLeft: -10 }}>
                                            <DataTable.Cell style={{ backgroundColor: '#eaedf3',width:200 }}>{item.story_title}</DataTable.Cell>
                                            <DataTable.Cell style={{ paddingLeft: 20 ,width:150}}>{item.working_hours}</DataTable.Cell>
                                            <DataTable.Cell style={{width:50}}>{moment(item.updated_date).format('ddd')}</DataTable.Cell>
                                            <DataTable.Cell style={{width:100}}>{item.updated_date}</DataTable.Cell>
                                            <DataTable.Cell style={{width:150}}>{item.fullname}</DataTable.Cell>

                                        </DataTable.Row>


                                    </DataTable>


                                )
                            }) : null}
                         
                            </View>
                           
                            </ScrollView>
                            <View style={{flexDirection:'row',backgroundColor:'#d5dce5',height:40}}>
                                <Text style={{width:220,paddingTop:10,fontWeight:'bold',paddingLeft:5 }}>Total Hours</Text>
                        <Text style={{paddingTop:10,fontWeight:'bold'}}>{getTotalHours()}</Text>
                            </View>
                    {/* </Content> */}

                </Container>
            // </KeyboardAvoidingView >
        );
    }
}

const styles = StyleSheet.create({
    container: {
        flex: 1,
        width: '90%',
        paddingLeft: hp('2%'),
    },
    footer: {
        position: 'absolute',
        flex: 0.1,
        left: 0,
        right: 0,
        bottom: -10,
        backgroundColor: 'green',
        flexDirection: 'row',
        height: 80,
        alignItems: 'center',
    },
    bottomButtons: {
        alignItems: 'center',
        justifyContent: 'center',
        flex: 1,
    },
    footerText: {
        color: 'white',
        fontWeight: 'bold',
        alignItems: 'center',
        fontSize: 18,
    },
    buttonContainer: {
        width: wp('90%'),
        alignSelf: 'baseline',
        marginBottom: 10,
        color: '#d2691e',
        marginLeft: 4,



    },
    signupButton: {

        backgroundColor: '#ffffff',
    },
    subcontainer: {
        flex: 2,
        flexDirection: 'row',
        paddingTop: 40
    },
    signUpText0: {
        fontSize: 13,
        color: 'green',
        paddingTop: 10,

    },
    signUpText1: {
        fontSize: 13,
        color: 'green',
        paddingTop: 10,

        paddingLeft: 10,
    },
    end: {

        alignItems: 'flex-end',

    },
    end1: {
        flex: 2,
        height: '50%',
        paddingTop: 20,
        justifyContent: 'space-between',

        flexDirection: 'row',
    },
    s: {
        justifyContent: 'center',

        backgroundColor: '#ed7070',
        shadowOffset: { width: 50, height: 50 },
        alignItems: 'center',
        width: wp('40%'),
        height: hp('12%'),

    },
    signUpText2: {
        fontSize: 13,
        marginLeft: 20,

        color: 'green',
        paddingTop: 10,
    },
    signUpText3: {

        fontSize: 13,
        paddingTop: 10,
        paddingLeft: 10,

        alignItems: 'center',
    },
    signUpText4: {
        fontSize: 13,
        paddingTop: 10,


        alignItems: 'center',
    },
    signup: {
        color: "#FFF",

    },
    boxone: {
        flex: 1,
        marginTop: 5,

    },
    boxtwo: {
        flex: 1,

    },
    boxthree: {
        flex: 1,

    },
    box: {
        flexDirection: 'row',
        position: 'relative',
        marginBottom: 10,


    },
    opensave: {
        // flex: 1,
        ...Platform.select({
            ios: {
                backgroundColor: 'green', height: 30, margin: 5, alignItems:
                    "center", justifyContent: 'center'
            },
            android: {
                backgroundColor: 'green', height: 30, margin: 5, alignItems:
                    "center", justifyContent: 'center'
            },
        }),
    },

    top: {
        // flex: 1,
        ...Platform.select({
            ios: {
                flex: 1, marginTop: 10, marginBottom: 10,
            },
            android: {
                flex: 1, marginTop: 10, marginBottom: 10, height: 400
            },
        }),
    },
    signUpText: {
        fontSize: 13,
        justifyContent: 'center',


        color: 'white',
        alignSelf: 'center',
    },
});