/*
FileName:AddEpic.js
Version:1.0.0
Purpose:Adding Epic to Backlogs
Devloper:Mahesh
*/
import React, { Component } from 'react';
import Requesteddata from '../AdminComponets/AdminRequestedDataProjects';
import { Platform, StyleSheet, Text, View, Dimensions, FlatList, TouchableHighlight, Image, TouchableOpacity, TextInput, Alert } from 'react-native';
import { Left, Button, Container, Header, Content, Item, Input } from 'native-base';
import AsyncStorage from '@react-native-community/async-storage';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import Modal from "react-native-simple-modal";
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import Toast from 'react-native-whc-toast';
import log from '../LogFile/Log';
import SearchableDropdown from 'react-native-searchable-dropdown';
import { ADDMODULE, MODULE_TITLE } from '../CommonComponents/Header';
import DatePicker from 'react-native-datepicker';

export default class AddEpic extends React.Component {

    constructor(props) {
        super(props);
        this.state = {
            open: false,
            modulename: '',
            epicName: 'Select Epic',
            moduleId: this.props.navigation.state.params.moduleId,
            taskid: this.props.navigation.state.params.taskid,
            role: '',
            userToken: '',
            modalVisible: false,
            action: this.props.navigation.state.params.action,//getting action
            idea_id: this.props.navigation.state.params.idea_id,//idea id
            idea_title: this.props.navigation.state.params.idea_title,//moduledesc
            idea_description: this.props.navigation.state.params.idea_description,
            error: '',
            resource: [],

            itemPressedDisabled: false,
        };
        this.getEpic();

    }
    //Open the Dialog Modal
    modalDidOpen = () => console.log("Modal did open.");
    //close the Dialog Modal
    modalDidClose = () => {
        this.props.navigation.goBack();
        this.setState({ open: false }); this.setState({ open: false });
        console.log("Modal did close.");

    };

    //Dialog actions start
    moveUp = () => this.setState({ offset: -100 });

    resetPosition = () => {
        this.setState({ offset: 0 });
        this.props.navigation.goBack();
    }

    //open the dialog 
    openModal = () => {
        this.setState({ open: true })

    };
    //close the dialog
    closeModal = () => {
        this.setState({ open: false });
        this.props.navigation.goBack();
    }
    //Dialog actions end
    componentDidMount() {
        log("Debug", "Module Add screen is loaded");
        this.openModal();
        this.getEpic();

        // this.setModalVisible(!this.state.modalVisible);
    }

    //Refresh data
    onRefresh() {
        this.setState({ isFetching: true }, function () { this.add() });
    }

    //getting the Employees list for addind maintask
    getEpic() {
        log("Info", " getEpic(cropcode) is used for getting the Epics list for adding Epic to userstory");
        // const { ModuleId } = this.state;
        // const { ideaid } = this.state;

        AsyncStorage.getItem("cropcode", (err, res) => {
            const cropcode = res;

            AsyncStorage.getItem("emp_role", (err, res) => {
                const emp_role = res;
                AsyncStorage.getItem("userToken", (err, res) => {
                    const userToken = res;
                    AsyncStorage.getItem("projectId", (err, res) => {
                        const projectId = res;
                        // alert("projectId"+projectId)
                        // alert("cropcode" + cropcode)
                        //  alert("emp_role" + emp_role)
                        // alert("Usertoken"+userToken)
                        NetInfo.fetch().then(state => {
                            if (state.type == "none") {
                                console.log(state.type);
                                log("Warn", "No internet connection");
                                Snackbar.show({
                                    title: 'No Internet Connection',
                                    backgroundColor: 'red',
                                    duration: Snackbar.LENGTH_LONG,
                                });
                            } else {
                                fetch(API + 'get_epics.php',
                                    {
                                        method: 'POST',
                                        headers: {
                                            Accept: 'application/json',
                                            'Content-Type': 'application/json',
                                        },
                                        body: JSON.stringify({
                                            corp: cropcode,
                                            action: "get_epics",
                                            userType: emp_role,
                                            empId: userToken,
                                            projectId: projectId,


                                        })
                                    })
                                    .then((response) => response.json())
                                    .then((responseJson) => {
                                        // alert(JSON.stringify(responseJson))
                                        if (responseJson.status === 'True') {

                                            var epicsList = [];
                                            responseJson.data.map((epics) => {
                                                return (
                                                    epicsList.push({
                                                        'id': epics.idea_id, 'name': epics.idea_title
                                                    })
                                                );
                                            })

                                            this.setState({
                                                resource: epicsList
                                            });
                                        }
                                    })
                                    .catch((error) => {
                                        console.error(error);
                                        log("Error", "requested projects error");
                                    });
                            }
                        });
                    });
                });
            });
        });
    }

    //Validatios
    isValid() {
        const { epicId } = this.state;
        let valid = false;

        if (epicId.length === 0) {
            log("Warn", "Epic should not be empty");
            this.setState({ error1: 'Select Epic' });
        }


        else {
            valid = true;
        }
        return valid;
    }


    //Modify the existing module
    addEpic() {
        log("Info", " addEpic(epicId, cropcode) is used Modify the existing module");
        const { epicId } = this.state;

        console.warn("epicId" + epicId);
        console.warn("taskid for epic" + this.state.taskid);


        //userToken and crop code getting
        AsyncStorage.multiGet(["cropcode", "userToken"], (err, response) => {
            const cropcode = response[0][1];
            const userToken = response[1][1];
            console.warn("userToken" + userToken);
            console.warn("cropcode" + cropcode);
            //Checking the Network connection
            NetInfo.fetch().then(state => {
                if (state.type == "none") {
                    console.log(state.type);
                    log("Warn", "No internet connection");
                    Snackbar.show({
                        title: 'No Internet Connection',
                        backgroundColor: 'red',
                        duration: Snackbar.LENGTH_LONG,
                    });
                } else {
                    if (this.isValid()) {
                        this.setState({ itemPressedDisabled: true })
                        fetch(API + 'getUpdateSprint.php',
                            {
                                method: 'POST',
                                headers: {
                                    Accept: 'application/json',
                                    'Content-Type': 'application/json',
                                },
                                body: JSON.stringify({
                                    action: "epic_update",
                                    crop: cropcode,
                                    epicId: epicId,
                                    updatedBy: userToken,
                                    userStoryId: this.state.taskid,

                                })
                            })
                            .then((response) => response.json())
                            .then((responseJson) => {
                                console.log(responseJson)

                                if (responseJson.status == 'True') {
                                    this.setState({ open: false });
                                    this.setState({ itemPressedDisabled: false })
                                    Snackbar.show({
                                        title: 'Epic Added Successfully',
                                        backgroundColor: 'green',
                                        duration: Snackbar.LENGTH_LONG,
                                    });

                                    //Navigate to AddModule screen
                                    // this.props.navigation.navigate("UserTaskStatus1");
                                    this.props.navigation.navigate("UserBacklog");

                                }
                                // this.refs.toast.show('Project Modified', Toast.Duration.long, Toast.Position.center);

                            })
                            .catch((error) => {
                                console.error(error);
                                log("Error", "Modify the existing module error");
                            });
                    }
                }
            });
        });

    }

    render() {

        return (
            <Modal
                offset={this.state.offset}
                closeOnTouchOutside={false}
                open={this.state.open}
                modalDidOpen={this.modalDidOpen}
                modalDidClose={this.modalDidClose}
                style={{ alignItems: "center" }} >

                <View style={{ alignItems: "center", }}>
                    <Toast ref="toast" />
                    <Text>Assign Epic</Text>

                    <View style={{ paddingTop: 20, width: '100%', marginLeft: '5%' }}>
                        <SearchableDropdown
                            placeholderTextColor='black'
                            placeholder={this.state.epicName}
                            onTextChange={text => console.log(text)}
                            value={this.state.epicId}
                            // onItemSelect={item => item.name}
                            onItemSelect={(item) => this.setState({ epicId: item.id, epicName: item.name })}
                            containerStyle={{ padding: 5, width: '96%' }}
                            textInputStyle={{
                                padding: 12,
                                borderWidth: 1,
                                borderColor: '#ccc',
                                backgroundColor: '#FAF7F6',
                            }}
                            itemStyle={{
                                padding: 10,
                                marginTop: 2,
                                backgroundColor: '#FAF9F8',
                                borderColor: '#bbb',
                                borderWidth: 1,
                            }}
                            itemTextStyle={{

                                color: '#222',
                            }}
                            itemsContainerStyle={{

                                // maxHeight: '60%',
                            }}
                            items={this.state.resource}

                            defaultIndex={2}

                            // placeholder=""

                            resetValue={false}

                            underlineColorAndroid="transparent"

                        />
                        <Text style={{ color: 'red' }}>{this.state.error}</Text>
                    </View>

                </View>

                <View style={{ flexDirection: 'row', marginTop: 20, alignItems: 'center', justifyContent: 'center', alignSelf: 'center', }}>
                    <TouchableOpacity style={styles.opensave} onPress={this.addEpic.bind(this)} disabled={this.state.itemPressedDisabled}>
                        <Text style={{ color: 'white' }}>SAVE</Text>
                    </TouchableOpacity>
                    <TouchableOpacity style={styles.opencancel} onPress={this.closeModal}>
                        <Text style={{ color: 'white' }}>CANCEL</Text>
                    </TouchableOpacity>
                </View>
            </Modal>


        );

    }

}
//Styles for UI
const styles = StyleSheet.create(
    {
        MainContainer:
        {
            flex: 1,
            width: Dimensions.get('window').width,
            height: Dimensions.get('window').height
        },
        bottomView: {
            flexDirection: 'row',
            justifyContent: 'center',
            position: 'absolute',
            height: FOOTER_MAX_HEIGHT,
            bottom: 0,
            left: 0,
            right: 0,
            backgroundColor: 'black',
            alignItems: 'center'
        },

        textStyle: {
            color: '#fff',
            fontSize: 18
        },
        container: {
            flex: 1,
            width: '90%',
            paddingLeft: hp('2%'),
        },
        footer: {
            position: 'absolute',
            flex: 0.1,
            left: 0,
            right: 0,
            bottom: -10,
            backgroundColor: 'green',
            flexDirection: 'row',
            height: 80,
            alignItems: 'center',
        },
        bottomButtons: {
            alignItems: 'center',
            justifyContent: 'center',
            flex: 1,
        },
        footerText: {
            color: 'white',
            fontWeight: 'bold',
            alignItems: 'center',
            fontSize: 18,
        },
        buttonContainer: {
            width: wp('90%'),
            alignSelf: 'baseline',
            marginBottom: 25,
            color: '#d2691e',
            marginLeft: 4,



        },
        signupButton: {

            backgroundColor: '#ffffff',
        },
        subcontainer: {
            flex: 2,
            flexDirection: 'row',
            paddingTop: 40
        },
        signUpText0: {
            fontSize: 13,
            color: 'green',
            paddingTop: 10,

        },
        signUpText1: {
            fontSize: 13,
            color: 'green',
            paddingTop: 10,

            paddingLeft: 10,
        },
        end: {

            alignItems: 'flex-end',

        },
        end1: {
            flex: 2,
            height: '50%',
            paddingTop: 20,
            justifyContent: 'space-between',

            flexDirection: 'row',
        },
        s: {
            justifyContent: 'center',

            backgroundColor: '#ed7070',
            shadowOffset: { width: 50, height: 50 },
            alignItems: 'center',
            width: wp('40%'),
            height: hp('12%'),

        },
        signUpText2: {
            fontSize: 10,
            marginLeft: 200,
            fontSize: 13,
            color: 'green',
            paddingTop: 10,

            //  marginRight: 10,
            //textAlign: "right"

        },
        signUpText3: {

            fontSize: 12,
            paddingTop: 10,
            paddingLeft: 10,

            alignItems: 'center',
        },
        signUpText4: {
            fontSize: 12,
            paddingTop: 10,


            alignItems: 'center',
        },
        signup: {
            //paddingTop:20,
            color: "#FFF",

        },
        boxone: {
            flex: 1,
            marginTop: 5,

        },
        boxtwo: {
            flex: 1,

        },
        boxthree: {
            flex: 1,

        },
        box: {
            flexDirection: 'row',
            position: 'relative',
            marginBottom: 10,


        },
        signUpText: {
            fontSize: 20,
            justifyContent: 'center',


            color: 'white',
            alignSelf: 'center',
        },
        opencancel: {
            flex: 1,
            ...Platform.select({
                ios: {
                    backgroundColor: 'red', margin: 20, height: 30, alignItems:
                        "center", justifyContent: 'center'
                },
                android: {
                    backgroundColor: 'red', margin: 20, height: 30, alignItems:
                        "center", justifyContent: 'center'
                },
            }),
        },
        opensave: {
            flex: 1,
            ...Platform.select({
                ios: {
                    backgroundColor: 'green', margin: 20, height: 30, alignItems:
                        "center", justifyContent: 'center'
                },
                android: {
                    backgroundColor: 'green', margin: 20, height: 30, alignItems:
                        "center", justifyContent: 'center'
                },
            }),
        },
    });