/*
FileName:EditUser.js
Version:1.0.0
Purpose:Modify or Edit option for existing Employee
Devloper:Rishitha,Mahesh
*/
import React, { Component } from 'react';
import { Platform, StyleSheet, Text, View, StatusBar, Dimensions, TouchableOpacity, Picker, Linking, TextInput, } from 'react-native';
import { Title, Button, Container, Content, Header, Right, Left, Body, Tab, Tabs, TabHeading, Footer, Item, Input, FooterTab } from 'native-base';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import Icon from 'react-native-vector-icons/MaterialCommunityIcons';
// import { Dropdown } from 'react-native-material-dropdown';
// import RNPickerSelect from 'react-native-picker-select';
// import RadioGroup from 'react-native-radio-button-group';
import AsyncStorage from '@react-native-community/async-storage';
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import log from '../LogFile/Log';
import { ScrollView } from 'react-native-gesture-handler';
import RadioButtonRN from 'radio-buttons-react-native';

import { EMPLOYEEID1, FULLNAME, USERNAME1, EMAIL1, MOBILE1, ADDEMPLOYEE, EMPLOYEEDETAILS, EDITEMPLOYEE } from '../CommonComponents/Header';

export default class EditUser extends Component {

    constructor(props) {
        super(props);

        this.state = {
            maintask: '',
            description: '',
            modalVisible: false,
            empId: this.props.navigation.state.params.empId,
            name: this.props.navigation.state.params.name,
            email: this.props.navigation.state.params.email,
            username: this.props.navigation.state.params.userName,
            mobile: this.props.navigation.state.params.mobile,
            designation: this.props.navigation.state.params.designation,
            role: this.props.navigation.state.params.role,
            workingStatus: this.props.navigation.state.params.workingStatus,
            team: this.props.navigation.state.params.team,
            fmanager: this.props.navigation.state.params.functionalManager,
            rmanager: this.props.navigation.state.params.reportingManager,
            dataSource: [],
            designationData: [],
            roleData: [],
            managerData: [],
        };
    }

    componentDidMount() {
        log("Debug", "Edit screen is loaded");
        this.empDesignationSearch();//Getting list of Empdesignation
        this.empRoleSearch();//Getting Employees list
        this.empManagerSearch();//Manager Search
        //alert(this.props.navigation.state.params.empId+this.props.navigation.state.params.role+this.props.navigation.state.params.designation)
    }
    //Update employe profile data
    UpdateEmployee() {
        log("Info", " getRequestedIdeas(cropcode,empId,name,email,username,mobile,designation,workingStatus,team,role) is used to get all details of user");
        AsyncStorage.getItem("cropcode", (err, res) => {

            const cropcode = res;
            AsyncStorage.getItem("projectId", (err, res) => {
                const projectId = res;

            const { empId } = this.state;
            const { name } = this.state;
            const { email } = this.state;
            const { username } = this.state;
            const { mobile } = this.state;
            const { designation } = this.state;
            const { workingStatus } = this.state;
            const { team } = this.state;
            const { role } = this.state;
            const { fmanager } = this.state;
            const { rmanager } = this.state;

            //checking the network connection
            NetInfo.fetch().then(state => {
                if (state.type == "none") {
                    console.log(state.type);
                    log("Warn", "No internet connection");
                    Snackbar.show({
                        title: 'No Internet Connection',
                        backgroundColor: 'red',
                        duration: Snackbar.LENGTH_LONG,
                    });
                } else {


                    fetch(API + 'manage_user.php', {
                        method: 'POST',
                        headers: {
                            'Accept': 'application/json',
                            'Content-Type': 'application/json',
                        },
                        body: JSON.stringify({
                            empId: empId,
                            fullname: name,
                            email: email,
                            username: username,
                            mobile: mobile,
                            designation: designation,
                            user_status: workingStatus,
                            team: team,
                            functionalManager: fmanager,
                            reportingManager: rmanager,
                            action: 'update',
                            userType: role,
                            corp: cropcode,
                            projectId:projectId,
                        })

                    }).then((response) => response.json())
                        .then((responseJson) => {
                            if (responseJson.status === 'True') {
                                // Showing response message coming from server after inserting records.
                                alert("Updated successfully");
                                this.props.navigation.navigate("UserManageEmployees")
                                // alert(JSON.stringify(responseJson));
                            }



                        }).catch((error) => {
                            console.error(error);
                            log("Error", " Error in Update employe profile data");
                        });
                }
            });
        });
    });
    }


    //fetch disgnation dropdown 
    empDesignationSearch() {
        log("Info", " empDesignationSearch(cropcode) is used to fetch disgnation dropdown ");
        AsyncStorage.getItem("cropcode", (err, res) => {

            const cropcode = res;
            NetInfo.fetch().then(state => {
                if (state.type == "none") {
                    console.log(state.type);
                    log("Warn", "No internet connection");
                    Snackbar.show({
                        title: 'No Internet Connection',
                        backgroundColor: 'red',
                        duration: Snackbar.LENGTH_LONG,
                    });
                } else {
                    fetch(API + 'spinner.php',
                        {
                            method: 'POST',
                            headers: {
                                Accept: 'application/json',
                                'Content-Type': 'application/json',
                            },
                            body: JSON.stringify({
                                crop: cropcode,
                                // mainTaskId: taskId,
                                action: 'desig'
                            })
                        })
                        .then((response) => response.json())
                        .then((responseJson) => {
                            this.setState({
                                isLoading: false,
                                designationData: [...responseJson.data],
                            }, function () {
                                // In this block you can do something with new state.
                            });
                            // const data2 = [];

                            // responseJson.data.map(x => {
                            //     data2.push({ label: x.value, value: x.value })
                            // })

                            // this.setState({
                            //     designationData: data2,
                            // });
                            // console.warn("HI000" + JSON.stringify(this.state.designationData))
                        }
                        )
                        .catch((error) => {
                            console.error(error);
                            log("Error", "fetch disgnation dropdown  error");
                        });
                }
            });
        });

    }

    //fetch role dropdown 
    empRoleSearch() {
        log("Info", "     empRoleSearc(cropcode) is used to fetch role dropdown  ");
        AsyncStorage.getItem("cropcode", (err, res) => {

            const cropcode = res;
            NetInfo.fetch().then(state => {
                if (state.type == "none") {
                    console.log(state.type);
                    log("Warn", "No internet connection");
                    Snackbar.show({
                        title: 'No Internet Connection',
                        backgroundColor: 'red',
                        duration: Snackbar.LENGTH_LONG,
                    });
                } else {
                    fetch(API + 'spinner.php',
                        {
                            method: 'POST',
                            headers: {
                                Accept: 'application/json',
                                'Content-Type': 'application/json',
                            },
                            body: JSON.stringify({
                                crop: cropcode,
                                // mainTaskId: taskId,
                                action: 'team'
                            })
                        })
                        .then((response) => response.json())
                        .then((responseJson) => {
                            this.setState({
                                isLoading: false,
                                dataSource: [...responseJson.data],
                            }, function () {
                                // In this block you can do something with new state.
                            });
                            // const data2 = [];

                            // responseJson.data.map(x => {
                            //     data2.push({ label: x.value, value: x.value })
                            // })
                            // console.warn("HI" + JSON.stringify(data2))
                            // this.setState({
                            //     roleData: data2,
                            // });
                        }
                        )
                        .catch((error) => {
                            console.error(error);
                            log("Error", "fetch role dropdown  error");
                        });
                }
            });
        });

    }

    //fetch disgnation dropdown 
    empManagerSearch() {
        log("Info", " empDesignationSearch(cropcode) is used to fetch disgnation dropdown ");
        AsyncStorage.getItem("cropcode", (err, res) => {

            const cropcode = res;
            NetInfo.fetch().then(state => {
                if (state.type == "none") {
                    console.log(state.type);
                    log("Warn", "No internet connection");
                    Snackbar.show({
                        title: 'No Internet Connection',
                        backgroundColor: 'red',
                        duration: Snackbar.LENGTH_LONG,
                    });
                } else {
                    fetch(API + 'getEmployees.php',
                        {
                            method: 'POST',
                            headers: {
                                Accept: 'application/json',
                                'Content-Type': 'application/json',
                            },
                            body: JSON.stringify({
                                crop: cropcode,
                                // mainTaskId: taskId,
                                action: "Manager",
                            })
                        })
                        .then((response) => response.json())
                        .then((responseJson) => {
                            console.warn("Manager data" + JSON.stringify(responseJson));
                            this.setState({
                                isLoading: false,
                                managerData: [...responseJson.data],
                            }, function () {
                                // In this block you can do something with new state.
                            });
                            // console.warn(JSON.stringify(responseJson));
                            // const data2 = [];

                            // responseJson.data.map((x) => {
                            //     data2.push({ label: x.name, value: x.name })
                            // })

                            // this.setState({
                            //     managerData: data2,
                            // });
                            // console.warn("Manager Data" + JSON.stringify(this.state.managerData))
                        }
                        )
                        .catch((error) => {
                            console.error(error);
                            log("Error", "fetch disgnation dropdown  error");
                        });
                }
            });
        });

    }

    render() {
        const data = [
            {
                label: 'Manager'
            },
            {
                label: 'Emp'
            },
            {
                label: 'Approver'
            }
        ];
        const data1 = [
            {
                label: 'Active'
            },
            {
                label: 'Inactive'
            },
            // {
            //     label: 'Other'
            // }
        ];
        return (
            <Container>

                <Header
                    androidStatusBarColor="#00A2C1"

                    style={{
                        backgroundColor: '#00A2C1',
                        height: 60,
                        width: Dimensions.get('window').width,
                        borderBottomColor: '#ffffff',
                        justifyContent: 'space-between',
                    }}>
                    <Left>
                        <Icon size={20} name="arrow-left" style={{ color: '#fff' }} onPress={() =>
                            this.props.navigation.goBack(null)} />
                    </Left>
                    <Body style={{ paddingRight: 60, }}>
                        <Title style={{ color: '#fff', fontWeight: '600', }}>Edit details</Title>
                    </Body>

                    <Right>

                    </Right>

                </Header>

                <Content>
                    <View>
                        <ScrollView>
                            <View >

                                <View style={{ paddingLeft: 10, }}>
                                    <Text style={{ fontSize: 20, color: 'black' }}>{EDITEMPLOYEE}</Text>




                                </View>
                                <View style={{ paddingLeft: 10, }}>

                                    <TextInput style={{ width: wp('95%'), height: 45, borderBottomWidth: 1, }}
                                        placeholder={EMPLOYEEID1}
                                        underlineColorAndroid='transparent'


                                        value={this.state.empId}
                                        onChangeText={(empId) => this.setState({ empId })}>

                                    </TextInput>


                                </View>

                                <View style={{ paddingLeft: 10, }}>


                                    <TextInput style={{ width: wp('95%'), height: 45, borderBottomWidth: 1, }}
                                        placeholder={FULLNAME}

                                        underlineColorAndroid='transparent'
                                        // selectionColor='white'
                                        value={this.state.name}
                                        onChangeText={(name) => this.setState({ name })}

                                    />
                                </View>
                                <View style={{ paddingLeft: 10, }}>


                                    <TextInput style={{ width: wp('95%'), height: 45, borderBottomWidth: 1, }}
                                        placeholder={EMAIL1}

                                        underlineColorAndroid='transparent'
                                        //selectionColor='white'
                                        value={this.state.email}
                                        onChangeText={(email) => this.setState({ email })}

                                    />
                                </View>
                                <View style={{ paddingLeft: 10, }}>


                                    <TextInput style={{ width: wp('95%'), height: 45, borderBottomWidth: 1, }}
                                        placeholder={USERNAME1}

                                        underlineColorAndroid='transparent'
                                        value={this.state.username}
                                        // selectionColor='white'
                                        onChangeText={(username) => this.setState({ username })}

                                    />
                                </View>
                                <View style={{ paddingLeft: 10, }}>


                                    <TextInput style={{ width: wp('95%'), height: 45, borderBottomWidth: 1, }}
                                        placeholder={MOBILE1}
                                        underlineColorAndroid='transparent'
                                        keyboardType={"number-pad"}
                                        value={this.state.mobile}
                                        //  selectionColor='white'
                                        onChangeText={(mobile) => this.setState({ mobile })}

                                    />
                                </View>

                            </View>

                            {/* <RNPickerSelect
                                //    style={{ paddingLeft: 10 }}
                                placeholder={{
                                    label: 'Select Designation',
                                    value: null,
                                    color: 'green',
                                }}
                                style={pickerSelectStyles}
                                value={this.state.designation}
                                onValueChange={(value) => this.setState({ designation: value })}
                                items={this.state.designationData}
                            /> */}
                            {/* <RNPickerSelect
                                // containerStyle={{ height: 40 ,}}
                                // style={{ paddingLeft: 10 }}
                                placeholder={{
                                    label: 'Select Team',
                                    value: null,
                                    color: 'green',
                                }}
                                style={pickerSelectStyles}
                                value={this.state.team}
                                onValueChange={(value) => this.setState({ team: value })}
                                items={this.state.roleData}
                            /> */}
                            {/* <RNPickerSelect
                                placeholder={{
                                    label: 'Select Functional Manager',
                                    value: null,
                                    color: 'green',
                                }}
                                // containerStyle={{ height: 40 ,}}
                                // style={{ paddingLeft: 10 }}
                                // pickerProps={{
                                //     accessibilityLabel: selectedItem.title,
                                // }}
                                style={pickerSelectStyles}
                                value={this.state.fmanager}
                                onValueChange={(value) => this.setState({ fmanager: value })}
                                items={this.state.managerData}
                            /> */}

                            {/* <RNPickerSelect
                                placeholder={{
                                    label: 'Select Reporting Manager',
                                    value: null,
                                    color: 'green',
                                }}
                                // containerStyle={{ height: 40 ,}}
                                // style={{ paddingLeft: 10 }}
                                style={pickerSelectStyles}
                                value={this.state.rmanager}
                                onValueChange={(value) => this.setState({ rmanager: value })}
                                items={this.state.managerData}
                            /> */}
                            {/* <Dropdown
                                //   ref={this.nameRef}
                                style={{ paddingLeft: 10 }}
                                value={this.state.designation}
                                onChangeText={typeValue => this.setState({ designation: typeValue })}

                                data={this.state.designationData}
                            /> */}
                            {/* <Dropdown
                                //   ref={this.nameRef}
                                style={{ paddingLeft: 10 }}
                                value={this.state.team}
                                onChangeText={typeValue => this.setState({ team: typeValue })}

                                data={this.state.roleData}
                            /> */}
                            <View style={{ paddingLeft: 10, paddingTop: 10, }}>
                                <Text>User Account Status</Text>
                                <RadioButtonRN
                                    data={data1}
                                    box={false}
                                    // value={this.state.workingStatus}
                                    // horizontal={true}
                                    // style={styles.types}
                                    // activeButtonId={this.state.workingStatus}
                                    selectedBtn={(option) => this.setState({ workingStatus: option.label })}
                                    circleStyle={{ fillColor: 'black', borderColor: 'black' }}
                                    icon={
                                        <Icon
                                            name="check-circle"
                                            size={25}
                                            color="black"
                                        />
                                    }
                                />
                                {/* <View style={{ flexDirection: 'row', paddingTop: 10, }}> */}

                                {/* <RadioGroup
                                        horizontal
                                        options={[
                                            {
                                                id: 'Active',
                                                labelView: (
                                                    <Text>
                                                        <Text style={{ color: 'Black' }}>Active</Text>
                                                    </Text>
                                                ),
                                            },
                                            {
                                                id: 'Inactive',
                                                labelView: (
                                                    <Text>
                                                        <Text style={{ color: 'black' }}>In-Active</Text>
                                                    </Text>
                                                ),
                                            },

                                            {
                                                id: 'Other',
                                                labelView: (
                                                    <Text>
                                                        <Text style={{ color: 'black' }}>Other</Text>
                                                    </Text>
                                                ),
                                            },

                                        ]}
                                        activeButtonId={this.state.workingStatus}
                                        value={this.state.workingStatus}
                                        circleStyle={{ fillColor: 'black', borderColor: 'black' }}
                                        onChange={(options) => this.setState({ workingStatus: options.id })}
                                    /> */}
                            </View>
                            {/* </View> */}

                            <View style={{ paddingLeft: 10, paddingTop: 10, }}>
                                {/* <Text>Select User Type</Text> */}
                                {/* <View style={{ flexDirection: 'row', paddingTop: 10, }}> */}
                                {/* <RadioButtonRN
                                    data={data}
                                    box={false}
                                    // horizontal={true}
                                    // style={styles.types}
                                    // activeButtonId={this.state.role}
                                    value={this.state.role}
                                    selectedBtn={(option) => this.setState({ role: option.label })}
                                    circleStyle={{ fillColor: 'black', borderColor: 'black' }}
                                    icon={
                                        <Icon
                                            name="check-circle"
                                            size={25}
                                            color="black"
                                        />
                                    }
                                /> */}
                                {/* 
                                    <RadioGroup
                                        horizontal
                                        options={[
                                            {
                                                id: 'Manager',
                                                labelView: (
                                                    <Text>
                                                        <Text style={{ color: 'Black' }}>Manager</Text>
                                                    </Text>
                                                ),
                                            },
                                            {
                                                id: 'Emp',
                                                labelView: (
                                                    <Text>
                                                        <Text style={{ color: 'black' }}>Employee </Text>
                                                    </Text>
                                                ),
                                            },

                                            {
                                                id: 'Approver',
                                                labelView: (
                                                    <Text>
                                                        <Text style={{ color: 'black' }}>Approver</Text>
                                                    </Text>
                                                ),
                                            },

                                        ]}
                                        activeButtonId={this.state.role}

                                        circleStyle={{ fillColor: 'black', borderColor: 'black' }}
                                        onChange={(options) => this.setState({ role: options.id })}
                                    /> */}
                                {/* <Picker
                                    selectedValue={this.state.team}
                                    value={this.state.team}
                                    onValueChange={(itemValue, itemIndex) => this.setState({ team: itemValue })} >

                                    {this.state.dataSource.map((item, key) => (
                                        <Picker.Item label={item.value} value={item.value} key={key} />)
                                    )}

                                </Picker> */}

                                {/* <Picker
                                    selectedValue={this.state.fmanager}

                                    onValueChange={(itemValue, itemIndex) => this.setState({ fmanager: itemValue })} >

                                    {this.state.designationData.map((item, key) => (
                                        <Picker.Item label={item.value} value={item.value} key={key} />)
                                    )}

                                </Picker> */}
                                {/* <Picker
                                    selectedValue={this.state.designation}

                                    onValueChange={(itemValue, itemIndex) => this.setState({ designation: itemValue })} >

                                    {this.state.managerData.map((item, key) => (
                                        <Picker.Item label={item.name} value={item.name} key={key} />)
                                    )}

                                </Picker> */}

                                {/* <Picker
                                    selectedValue={this.state.rmanager}

                                    onValueChange={(itemValue, itemIndex) => this.setState({ rmanager: itemValue })} >

                                    {this.state.managerData.map((item, key) => (
                                        <Picker.Item label={item.name} value={item.name} key={key} />)
                                    )}

                                </Picker> */}


                            </View >
                            {/* </View> */}
                            {/* update all data  */}
                            <View style={{ flexDirection: 'row', justifyContent: 'center', alignItems: 'center', }}>
                                <TouchableOpacity onPress={this.UpdateEmployee.bind(this)} style={{ backgroundColor: '#00A2C1', borderRadius: 5, height: 30, alignItems: "center", justifyContent: 'center' }}>
                                    <Text style={{ color: 'white' }}> SUBMIT</Text>
                                </TouchableOpacity>

                            </View>
                        </ScrollView>
                    </View>
                </Content>
            </Container>
        );
    }
}

const pickerSelectStyles = StyleSheet.create({
    inputIOS: {
        fontSize: 16,
        paddingVertical: 12,
        paddingHorizontal: 10,
        borderWidth: 1,
        borderColor: 'gray',
        borderRadius: 4,
        color: 'black',
        paddingRight: 30, // to ensure the text is never behind the icon
    },
    inputAndroid: {
        fontSize: 16,
        paddingHorizontal: 10,
        paddingVertical: 8,
        borderWidth: 0.5,
        borderColor: 'purple',
        borderRadius: 8,
        color: 'black',
        paddingRight: 30, // to ensure the text is never behind the icon
    },
});
