import React, { Component } from 'react';
import {
  Platform, StyleSheet, TextPropTypes, Picker, Text, View, Image, StatusBar, Dimensions, TextInput, Alert,
  KeyboardAvoidingView,
  TouchableWithoutFeedback,
  Keyboard
} from 'react-native';
// import { Chart, VerticalAxis, HorizontalAxis, Line } from 'react-native-responsive-linechart'
import { Icon, Title, Container, Content, Header, Right, Left, Body } from 'native-base';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import { TouchableOpacity } from 'react-native-gesture-handler';
import AsyncStorage from '@react-native-community/async-storage';
import { ReportsAPI } from "../WebServices/RestClient";
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import Snackbar from 'react-native-snackbar';
import log from '../LogFile/Log';
import ProffileOffline from '../OfflineDB/Profile';
const db = new ProffileOffline();
import Main from '../Maintenance/Main';
import jwt_decode from "jwt-decode";
import ModalSelector from 'react-native-modal-selector';
const check = new Main()
import {
  DotIndicator,
} from 'react-native-indicators';
// import { LineChart, BarChart } from "react-native-chart-kit";
import { ScrollView } from 'react-native-gesture-handler';
import { PROFILE, CHANGEPASSWORD, EMPLOYEEID, USERNAME, EMAIL, MOBILE, FULLNAME1, DESIGNATION, TEAM, ROLE, FMANAGER, RMANAGER, STATUS1 } from '../CommonComponents/Header';
import SearchableDropdown from 'react-native-searchable-dropdown';
import PureChart from 'react-native-pure-chart';

export default class Reports extends Component {

  constructor(props) {
    super(props);

    this.state = {
      isLoading: false,
      isVisibleB: false,
      sprintVelocity: [],
      sprint: [],
      indVelocity: [],
      indWorkload: [],
      epicVelocity:[],
      selectedIndVelocity: [],
      // indWorkload: [],
      dataSource: [],
      dataSource1: [],

      assignedName: 'Select Squad Name',
      sprintName: 'Select Sprint Name',
      epicName: 'Select Epic',
      resource: [],
      resource1: [],
      resource2:[],
      burnUpChart: [],


    }
    AsyncStorage.getItem("cropcode", (err, res) => {
      this.setState({ squadName: res });
      console.warn("squadname" + this.state.squadName);
    });
  }



  componentDidMount() {
    this.getEmployees();
    this.Network();
    this.Network1();
    this.getSprints();
    this.GetStatus();
    this.getEpics();
  }

  //getting the Employees list for addind maintask
  getEmployees() {
    log("Info", " getEmployees(cropcode) is used for getting the Employees list for addind maintask");
    const { ModuleId } = this.state;
    const { ideaid } = this.state;

    AsyncStorage.getItem("cropcode", (err, res) => {
      const cropcode = res;
      AsyncStorage.getItem("projectId", (err, res) => {
        const projectId = res;
        NetInfo.fetch().then(state => {
          if (state.type == "none") {
            console.log(state.type);
            log("Warn", "No internet connection");
            Snackbar.show({
              title: 'No Internet Connection',
              backgroundColor: 'red',
              duration: Snackbar.LENGTH_LONG,
            });
          } else {
            fetch(API + 'agile_squads.php',
              {
                method: 'POST',
                headers: {
                  Accept: 'application/json',
                  'Content-Type': 'application/json',
                },
                body: JSON.stringify({
                  crop: cropcode,
                  projectId: projectId
                })
              })
              .then((response) => response.json())
              .then((responseJson) => {
                if (responseJson.status === 'True') {

                  var empList = [];
                  responseJson.data.map((employee) => {
                    return (
                      empList.push({
                        'id': employee.id, 'name': employee.name
                      })
                    );
                  })
                  //  alert("Employee Data"+JSON.stringify(responseJson))
                  // this.Network1()
                  this.setState({
                    resource: responseJson.data
                  });
                }
              })
              .catch((error) => {
                console.error(error);
                log("Error", "requested projects error");
              });
          }
        });
      });
    });
  }


  //get Sprints data

  // getSprints() {
  //   log("Info", " getEmployees(cropcode) is used for getting the Employees list for addind maintask");
  //   const { ModuleId } = this.state;
  //   const { ideaid } = this.state;

  //   AsyncStorage.getItem("cropcode", (err, res) => {
  //     const cropcode = res;
  //     NetInfo.fetch().then(state => {
  //       if (state.type == "none") {
  //         console.log(state.type);
  //         log("Warn", "No internet connection");
  //         Snackbar.show({
  //           title: 'No Internet Connection',
  //           backgroundColor: 'red',
  //           duration: Snackbar.LENGTH_LONG,
  //         });
  //       } else {
  //         fetch(API + 'archive.php',
  //           {
  //             method: 'POST',
  //             headers: {
  //               Accept: 'application/json',
  //               'Content-Type': 'application/json',
  //             },
  //             body: JSON.stringify({
  //               crop: cropcode,
  //               action: "getCompletedSprints"
  //             })
  //           })
  //           .then((response) => response.json())
  //           .then((responseJson) => {
  //             if (responseJson.status === 'True') {

  //               // alert(JSON.stringify(responseJson))

  //               var sprintDetails = [];

  //               responseJson.data.map((sprints) => {
  //                 const [year, month, date] = sprints.startDate.split('-');
  //                 const [year1, month1, date1] = sprints.targetDate.split('-');
  //                 return (
  //                   sprintDetails.push({ 'id': sprints.moduleId, 'epicId': sprints.ideaId, 'name': sprints.moduleDesc.concat('[' + month + '.' + date + '.' + year + '-' + month1 + '.' + date1 + '.' + year1 + ']') })
  //                 );
  //               })

  //               this.setState({
  //                 resource1: sprintDetails
  //               });
  //             }
  //           })
  //           .catch((error) => {
  //             console.error(error);
  //             log("Error", "requested projects error");
  //           });
  //       }
  //     });
  //   });
  // }


  //Getting the Srpint velocity
  getSprints() {
    // alert("Testing")
    AsyncStorage.getItem("cropcode", (err, res) => {
      const cropcode = res;
      console.warn(cropcode);
      AsyncStorage.getItem("userToken", (err, res) => {
        const empId = res;
        AsyncStorage.getItem("projectId", (err, res) => {
          const projectId = res;
          console.warn(empId);
          NetInfo.fetch().then(state => {
            if (state.type == "none") {
              Snackbar.show({
                title: 'No Internet Connection',
                backgroundColor: 'red',
                duration: Snackbar.LENGTH_LONG,
              });
            } else {

              fetch(ReportsAPI + 'getEpics', {
                method: 'POST',
                headers: {
                  'Accept': 'application/json',
                  'Content-Type': 'application/json',
                },
                body: JSON.stringify({
                  corp: cropcode,
                  project_id: projectId,
                })

              }).then((response) => response.json())
                .then((responseJson) => {
                  // console.warn("Sprint Velocity" + JSON.stringify(responseJson));
                  // alert("getEpics Data"+JSON.stringify(responseJson))

                  // this.setState({
                  //   resource1: responseJson

                  // },

                  //   function () {

                  //   });


                  var epicList = [];
                  responseJson.map((sprints) => {
                    return (
                      epicList.push({
                        'id': sprints.epic_id, 'name': sprints.epic_name
                      })
                    );
                  })

                  this.setState({
                    resource2: epicList
                  },
                    function () {

                    }
                  );

                }).catch((error) => {
                  check.Maintenance();
                  console.error(error);
                  log("Error", "Error in getting profile data");

                });
            }
          });
        });
      });

    });
  }


  //Getting the Srpint velocity
  Network() {

    AsyncStorage.getItem("cropcode", (err, res) => {
      const cropcode = res;
      console.warn(cropcode);
      AsyncStorage.getItem("userToken", (err, res) => {
        const empId = res;
        AsyncStorage.getItem("projectId", (err, res) => {
          const projectId = res;
          // alert(projectId);
          NetInfo.fetch().then(state => {
            if (state.type == "none") {
              Snackbar.show({
                title: 'No Internet Connection',
                backgroundColor: 'red',
                duration: Snackbar.LENGTH_LONG,
              });
            } else {

              fetch(ReportsAPI + 'sprintVelocity', {
                method: 'POST',
                headers: {
                  'Accept': 'application/json',
                  'Content-Type': 'application/json',
                },
                body: JSON.stringify({
                  corp: cropcode,
                  project_id: projectId
                })


              }).then((response) => response.json())
                .then((responseJson) => {
                  // alert("Sprint Velocity" + JSON.stringify(responseJson));
                  // alert("Sprint Velocity1" + sprintVelocity);
                  // alert(JSON.stringify(responseJson))

                  this.setState({
                    sprintVelocity: responseJson

                  },

                    function () {

                    });
                }).catch((error) => {
                  check.Maintenance();
                  console.error(error);
                  log("Error", "Error in getting profile data");

                });
            }
          });
        });
      });

    });
  }

  getEpics() {
    // alert("Testing")
    AsyncStorage.getItem("cropcode", (err, res) => {
      const cropcode = res;
      console.warn(cropcode);
      AsyncStorage.getItem("userToken", (err, res) => {
        const empId = res;
        AsyncStorage.getItem("projectId", (err, res) => {
          const projectId = res;
          console.warn(empId);
          NetInfo.fetch().then(state => {
            if (state.type == "none") {
              Snackbar.show({
                title: 'No Internet Connection',
                backgroundColor: 'red',
                duration: Snackbar.LENGTH_LONG,
              });
            } else {

              fetch(ReportsAPI + 'sprints', {
                method: 'POST',
                headers: {
                  'Accept': 'application/json',
                  'Content-Type': 'application/json',
                },
                body: JSON.stringify({
                  corp: cropcode,
                  project_id: projectId,
                })

              }).then((response) => response.json())
                .then((responseJson) => {
                  // console.warn("Sprint Velocity" + JSON.stringify(responseJson));
                  // alert("Sprint Data"+JSON.stringify(responseJson))

                  // this.setState({
                  //   resource1: responseJson

                  // },

                  //   function () {

                  //   });


                  var sprintList = [];
                  responseJson.map((sprints) => {
                    return (
                      sprintList.push({
                        'id': sprints.sprint_id, 'name': sprints.sprint
                      })
                    );
                  })

                  this.setState({
                    resource1: sprintList
                  },
                    function () {

                    }
                  );

                }).catch((error) => {
                  check.Maintenance();
                  console.error(error);
                  log("Error", "Error in getting profile data");

                });
            }
          });
        });
      });

    });
  }



  NetworkData(item) {
    // this.Network2(item);
    // this.Network3(item);
  }

  //Getting the indVelocity
  // Network1(assigned_to) {
  //   // alert(assigned_to)
  //   AsyncStorage.getItem("cropcode", (err, res) => {
  //     const cropcode = res;
  //     console.warn(cropcode);
  //     AsyncStorage.getItem("userToken", (err, res) => {
  //       AsyncStorage.getItem("projectId", (err, res) => {
  //         const projectId = res;
  //         const empId = res;
  //         console.warn(empId);
  //         // console.warn(item)
  //         NetInfo.fetch().then(state => {
  //           if (state.type == "none") {
  //             Snackbar.show({
  //               title: 'No Internet Connection',
  //               backgroundColor: 'red',
  //               duration: Snackbar.LENGTH_LONG,
  //             });
  //           } else {

  //             // fetch(ReportsAPI + '/api/sprint?databaseName=' + cropcode, {
  //             fetch(ReportsAPI + `individualWorkload`, {

  //               method: 'POST',
  //               headers: {
  //                 'Accept': 'application/json',
  //                 'Content-Type': 'application/json',
  //               },
  //               body: JSON.stringify({
  //                 // corp: cropcode,
  //                 assigned_to: assigned_to,

  //                 projectId: projectId,
  //               })


  //             }).then((response) => response.json())
  //               .then((responseJson) => {
  //                 // alert("individualWorkload" + JSON.stringify(responseJson));
  //                 alert(JSON.stringify(responseJson))

  //                 this.setState({
  //                   indWorkload: responseJson

  //                 },
  //                   function () {

  //                   });
  //               }).catch((error) => {
  //                 check.Maintenance();
  //                 console.error(error);
  //                 log("Error", "Error in getting profile data");

  //               });
  //           }
  //         });
  //       });
  //     });

  //   });
  // }


   //Getting the indVelocity
   Network1(id) {

    // alert("adding id"+id)
    AsyncStorage.getItem("cropcode", (err, res) => {
      const cropcode = res;
      console.warn(cropcode);
      AsyncStorage.getItem("projectId", (err, res) => {
        const projectId = res;

      AsyncStorage.getItem("userToken", (err, res) => {
        const empId = res;
        console.warn(empId);
        // console.warn(item)
        NetInfo.fetch().then(state => {
          if (state.type == "none") {
            Snackbar.show({
              title: 'No Internet Connection',
              backgroundColor: 'red',
              duration: Snackbar.LENGTH_LONG,
            });
          } else {

            // fetch(ReportsAPI + '/api/sprint?databaseName=' + cropcode, {
            fetch(ReportsAPI +'individualWorkload',{ 

              method: 'POST',
              headers: {
                'Accept': 'application/json',
                'Content-Type': 'application/json',
              },
              body: JSON.stringify({
                assigned_to:id,
                project_id: projectId, 
              })

            }).then((response) => response.json())
              .then((responseJson) => {
                // console.warn("Sprint" + JSON.stringify(responseJson));
                //  alert(JSON.stringify(responseJson))

                this.setState({
                  indWorkload: responseJson

                },

                  function () {

                  });
              }).catch((error) => {
                check.Maintenance();
                console.error(error);
                log("Error", "Error in getting profile data");

              });
          }
        });
      });
  });
    });
  }

  //Getting the indVelocity
  Network2(id) {
    // alert(id)
    // this.Network3(item);
    AsyncStorage.getItem("cropcode", (err, res) => {
      const cropcode = res;
      console.warn(cropcode);
      AsyncStorage.getItem("userToken", (err, res) => {
        const empId = res;
        AsyncStorage.getItem("projectId", (err, res) => {
          const projectId = res;
          console.warn(empId);
          NetInfo.fetch().then(state => {
            if (state.type == "none") {
              Snackbar.show({
                title: 'No Internet Connection',
                backgroundColor: 'red',
                duration: Snackbar.LENGTH_LONG,
              });
            } else {

              fetch(ReportsAPI + `individualSprintVelocity`, {
                method: 'POST',
                headers: {
                  'Accept': 'application/json',
                  'Content-Type': 'application/json',
                },
                body: JSON.stringify({
                  corp: cropcode,
                  sprint_id: id,
                })

              }).then((response) => response.json())
                .then((responseJson) => {
                  // alert("individualSprintVelocity" + JSON.stringify(responseJson));
                  //alert(JSON.stringify(responseJson))

                  this.setState({
                    indVelocity: responseJson

                  },

                    function () {

                    });
                }).catch((error) => {
                  check.Maintenance();
                  console.error(error);
                  log("Error", "Error in getting profile data");

                });
            }
          });
        });
      });
    });
  }

   //Getting the indVelocity
   NetworkEpic(id) {
    // alert(id)
    // this.Network3(item);
    AsyncStorage.getItem("cropcode", (err, res) => {
      const cropcode = res;
      console.warn(cropcode);
      AsyncStorage.getItem("userToken", (err, res) => {
        const empId = res;
        AsyncStorage.getItem("projectId", (err, res) => {
          const projectId = res;
          console.warn(empId);
          NetInfo.fetch().then(state => {
            if (state.type == "none") {
              Snackbar.show({
                title: 'No Internet Connection',
                backgroundColor: 'red',
                duration: Snackbar.LENGTH_LONG,
              });
            } else {

              fetch(ReportsAPI + `getEpicsData`, {
                method: 'POST',
                headers: {
                  'Accept': 'application/json',
                  'Content-Type': 'application/json',
                },
                body: JSON.stringify({
                  corp: cropcode,
                  epic_id: id,
                })

              }).then((response) => response.json())
                .then((responseJson) => {
                  // alert("epics" + JSON.stringify(responseJson));
                  // alert("abcd"+JSON.stringify(responseJson))

                  var epicDataX = [];
                  var epicDataY = [];
                  responseJson.map((x) => {
                    return (
                      epicDataX.push({ 'x': x.sprint, 'y': parseInt(x.estimated) })
                    );
                  })
                  responseJson.map((x) => {
                    return (
                      epicDataY.push({ 'x': x.sprint, 'y': parseInt(x.completed)})
                    );
                  })

                  this.setState({
                    epicVelocity: [
                      {
                        seriesName: 'series1', data: epicDataX, color: 'grey'
                      },
                      {
                        seriesName: 'series2', data: epicDataY, color: 'green'
                      }
                    ]

                  },

                    function () {

                    });
                }).catch((error) => {
                  check.Maintenance();
                  console.error(error);
                  log("Error", "Error in getting profile data");

                });
            }
          });
        });
      });
    });
  }


  //Getting the indVelocity
  Network3(item) {
    // alert(item)
    AsyncStorage.getItem("cropcode", (err, res) => {
      const cropcode = res;
      console.warn(cropcode);
      AsyncStorage.getItem("userToken", (err, res) => {
        const empId = res;
        console.warn(empId);
        NetInfo.fetch().then(state => {
          if (state.type == "none") {
            Snackbar.show({
              title: 'No Internet Connection',
              backgroundColor: 'red',
              duration: Snackbar.LENGTH_LONG,
            });
          } else {

            fetch(ReportsAPI + `/api/burnUp?moduleId=${item}&databaseName=` + cropcode, {
              method: 'GET',
              headers: {
                'Accept': 'application/json',
                'Content-Type': 'application/json',
              },

            }).then((response) => response.json())
              .then((responseJson) => {
                // console.warn("Sprint" + JSON.stringify(responseJson));
                // alert(JSON.stringify(responseJson))

                this.setState({
                  burnUpChart: responseJson

                },

                  function () {

                  });
              }).catch((error) => {
                check.Maintenance();
                console.error(error);
                log("Error", "Error in getting profile data");

              });
          }
        });
      });

    });
  }

  //get project list dropdown data
  GetStatus() {
    log("Info", "UserProfile:GetStatus() method is used to get status of employee");
    AsyncStorage.getItem("userToken", (err, res) => {
      const empId = res;
      NetInfo.fetch().then(state => {
        if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
          // console.log(state.type);
          Snackbar.show({
            title: 'No Internet Connection',
            backgroundColor: 'red',
            duration: Snackbar.LENGTH_LONG,
          });
          this.getAgileProjects()//For Getting Project List in Offline
        } else {

          fetch(API + 'squads.php', {
            method: 'POST',
            headers: {
              Accept: 'application/json',
              'Content-Type': 'application/json',
            },
            body: JSON.stringify({

              empId: empId,
              action: 'get_squads',


            })
          })
            .then((response) => response.json())
            .then((responseJson) => {
              console.warn(responseJson)
              // alert(JSON.stringify(responseJson))
              if (responseJson.status == 'True') {
                // this.addAgileProjects(responseJson.data) //Project list store in offline
                // this.setState({
                //     isLoading: false,
                //     dataSource: [...responseJson.data],
                // }, function () {
                //     // In this block you can do something with new state.
                // });


                var dataSource = [];
                responseJson.data.map((epics) => {
                  return (
                    dataSource.push({
                      'key': epics.value, 'label': epics.value
                    })
                  );
                })

                this.setState({
                  dataSource: dataSource
                });

                // const data2 = [];

                // responseJson.data.map(x => {
                //     data2.push({ label: x.value, value: x.value })
                // })
                // this.setState({
                //     data2: data2,
                // })
                // console.warn("Hello" + JSON.stringify(data2))

                // this.setState({
                //     data2: responseJson.data
                // });
                // console.warn(this.state.data2);
              } else {
                this.setState({
                  dataSource: dataSource
                });
                log("Warn", "status of employee is not available");
              }
            })
            .catch((error) => {
              console.error(error);
              log("Error", "error in  getting status of employee");
            });
        }
      });
    });

  }

  // Update Status of Employee
  UpdateStatus(squadName) {
    // const { squadName } = this.state;
    log("Info", "UserProfile:UpdateStatus(status) method is used to update status of employee");
    console.warn("Hello" + squadName);

    AsyncStorage.getItem("userName", (err, res) => {
      const userName = res;
      console.log(res);



      // console.log(cropcode);
      NetInfo.fetch().then(state => {
        if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
          console.log(state.type);
          Snackbar.show({
            title: 'No Internet Connection',
            backgroundColor: 'red',
            duration: Snackbar.LENGTH_LONG,
          });
          //for offline project switching start
          this.setState({
            squadName: squadName
          });
          AsyncStorage.setItem('cropcode', squadName);
          this.getOfflineSprints()//Getting the List of offline Sprints
          this.getOfflineActiveSprints("currentsprint") //Getting Current Sprint Backlogs in offline
          //for offline project switching end
        } else {

          fetch(API + 'squadLogin.php', {
            method: 'POST',
            headers: {
              Accept: 'application/json',
              'Content-Type': 'application/json',
            },
            body: JSON.stringify({
              username: userName,
              crop: squadName,

            })
          })
            .then((response) => response.json())
            .then((responseJson) => {
              console.warn(JSON.stringify(responseJson))

              if (responseJson.status == 'TRUE') {
                AsyncStorage.setItem('auth', responseJson.jwt) //store the token information  with exp
                const tokenDetails = jwt_decode(responseJson.jwt);
                console.log(tokenDetails.data)
                AsyncStorage.setItem('roleCount', tokenDetails.data.roleCount)
                // dispatch(setCurrentUser(tokenDetails.data)); //store the user information
                AsyncStorage.setItem('status', tokenDetails.data.empStatus)


                AsyncStorage.setItem('userToken', tokenDetails.data.empId);
                AsyncStorage.setItem('userName', tokenDetails.data.userName);
                AsyncStorage.setItem('emp_role', tokenDetails.data.role);
                AsyncStorage.setItem('cropcode', tokenDetails.data.corp);

                // alert("project changed")
                // this.props.navigation.navigate('UserProfile');
                // console.warn("HI" + empstatus)
                this.setState({

                  squadName: squadName
                });
                this.Network();
                this.getEmployees();
                this.getSprints();
                //  alert("Project Changed Successfully")


              } else {
                //    alert("user already exist");
                log("Warn", "status of employee is not able to update");
              }

            })
            .catch((error) => {
              console.warn(error);
              log("Error", "error in updating status of employee");
            });
        }
      });
    });

  }



  render() {
    if (this.state.isLoading) {
      return (
        <View style={{ flex: 1, alignItems: 'center', justifyContent: 'center' }}>
          <DotIndicator color='#00A2C1' />
        </View>
      );

    }
    var sprintDataX = [];
    var sprintDataY = [];
    // alert(JSON.stringify(this.state.sprintVelocity))
    this.state.sprintVelocity.map((x) => {
      return (
        sprintDataX.push({ 'x': x.sprint, 'y': parseInt(x.estimated) })
      );

    })
    // alert(JSON.stringify(sprintDataX))
    this.state.sprintVelocity.map((x) => {
      return (
        sprintDataY.push({ 'x': x.sprint, 'y': parseInt(x.completed) })
      );
    })

// alert(JSON.stringify(sprintDataX))

    const sprintData = [

      {
        seriesName: 'series1',
        color: 'grey',


        data: sprintDataX

        // data: this.state.sprintVelocity.map(x => x.estimated)
        // data: [{x:this.state.sprintVelocity.map(x => x.sprint),y:this.state.sprintVelocity.map(y => y.estimated)}],
        // data1:this.state.sprintVelocity.map(y => y.sprint)
      },

      {
        seriesName: 'series2',
        color: 'green',
        labelWidth: 200,
        label: "Completed",
        data: this.state.sprintVelocity.map(x => parseInt(x.completed)),
        // data: [{x:this.state.sprintVelocity.map(x => x.sprint),y:this.state.sprintVelocity.map(y => y.completed)}],

      }
    ]

    var epicDataX = [];
    var epicDataY = [];
    this.state.epicVelocity.map((x) => {
      return (
        epicDataX.push({ 'x': x.sprint, 'y': parseInt(x.estimated) })
      );
    })
    this.state.epicVelocity.map((x) => {
      return (
        epicDataY.push({ 'x': x.sprint, 'y': parseInt(x.completed)})
      );
    })

//  alert("abc"+JSON.stringify(this.state.epicVelocity))

    const epicVelocityChart = [
      
        {
          seriesName: 'test2', data: epicDataX, color: '#0e95de'
        }
      
 
  ]

    var individualDataX = [];
    var individualDataY = [];
    this.state.indVelocity.map((x) => {
      return (
        individualDataX.push({ 'x': x.fullname, 'y': parseInt(x.estimated) })
      );
    })
    this.state.indVelocity.map((x) => {
      return (
        individualDataY.push({ 'x': x.fullname, 'y': parseInt(x.completed) })
      );
    })


    const individualVelocity = [
      {
        seriesName: 'series1',
        color: 'grey',
        label: "Committed",
        // data: this.state.indVelocity.map(x => x.estimated)
        data: individualDataX
      },

      {
        seriesName: 'series2',
        color: 'green',

        label: "Completed",
        // data: this.state.indVelocity.map(x => x.completed)
        data: individualDataY

      }
    ]

    let sampleData = [
      {
        seriesName: 'series1',
        data: [
          {x: '2018-02-01', y: 30},
          {x: '2018-02-02', y: 200},
          {x: '2018-02-03', y: 170},
          {x: '2018-02-04', y: 250},
          {x: '2018-02-05', y: 10}
        ],
        color: '#297AB1'
      },
      {
        seriesName: 'series2',
        data: [
          {x: '2018-02-01', y: 20},
          {x: '2018-02-02', y: 100},
          {x: '2018-02-03', y: 140},
          {x: '2018-02-04', y: 550},
          {x: '2018-02-05', y: 40}
        ],
        color: 'yellow'
      }
    ]

    var workloadDataX = [];
    var workloadDataY = [];
    this.state.indWorkload.map((x) => {
      return (
        workloadDataX.push({ 'x': x.sprintName, 'y': parseInt(x.estimated) })
      );
    })
    this.state.indWorkload.map((x) => {
      return (
        workloadDataY.push({ 'x': x.sprintName, 'y': parseInt(x.completed )})
      );
    })
// alert(JSON.stringify(workloadDataX))
    const individualWorkload = [
      {
        seriesName: 'series1',
        color: 'grey',
        label: "Committed",
        // data: this.state.indWorkload.map(x => x.estimated)
        data: workloadDataX
      },

      {
        seriesName: 'series2',
        color: 'green',

        label: "Completed",
        // data: this.state.indWorkload.map(x => x.completed)
        data: workloadDataY

      }
    ]

    const sprintBurnUpChart = [
      {
        seriesName: 'series1',
        color: 'grey',
        label: "Committed",
        data: this.state.burnUpChart.map(x => x.estimated)
      },

      {
        seriesName: 'series2',
        color: 'green',

        label: "Completed",
        data: this.state.burnUpChart.map(x => x.completed)

      }
    ]


    return (
      <KeyboardAvoidingView
        style={{ flex: 1 }}
        behavior={Platform.OS === "ios" ? "padding" : "height"}
      >
        <Container>
          {/* <Header
          androidStatusBarColor="#00A2C1"
          style={{
            backgroundColor: '#00A2C1',
            height: 60,
            width: Dimensions.get('window').width,
            borderBottomColor: '#ffffff',
            justifyContent: 'space-between',
          }}>
          <Left>
            <Icon name="md-menu" style={{ color: '#fff' }} onPress={() =>
              this.props.navigation.toggleDrawer()} />
          </Left>
          <Body>
            <Title style={{ color: '#fff', fontWeight: '600' }}>REPORTS</Title>
          </Body>


        </Header> */}

          <Header
            androidStatusBarColor="#00A2C1"
            style={{
              backgroundColor: '#00A2C1',
              height: 60,
              width: Dimensions.get('window').width,
              borderBottomColor: '#ffffff',
              justifyContent: 'space-between',
            }}>
            <View style={{ marginTop: 20 }}>
              <Icon name="md-menu" size={25} style={{ color: 'white', }} onPress={() =>
                this.props.navigation.toggleDrawer()} />
            </View>

            <View style={{ width: 300, borderRadius: 20, height: 45, marginTop: 5, flexDirection: 'row' }}>


              <ModalSelector
                style={{ width: 260, backgroundColor: 'transparent', borderColor: 'transparent', marginLeft: 60 }}
                data={this.state.dataSource}
                initValue={this.state.squadName}
                optionContainerStyle={{ backgroundColor: 'white' }}
                onChange={(itemValue) => { this.UpdateStatus(itemValue.label) }} >
                <View style={{ width: 300, borderRadius: 20, height: 45, marginTop: 5, flexDirection: 'row' }}>
                  <Text style={{ marginTop: 15, color: 'white', width: 80 }}>PROJECT : </Text>

                  <Text style={{ marginTop: 15, color: 'white', width: 120, }}>{this.state.squadName}</Text>

                  <Icon name="md-chevron-down-outline" size={25} style={{ color: 'white', marginTop: 10, }}
                  />
                </View>

              </ModalSelector>


            </View>

          </Header>
          <Content>

            {/* Sprint Velocity */}
            <View style={{ flex: 1, marginTop: 10, marginBottom: 10 }}>
              <Text style={{ padding: 10, fontWeight: 'bold' }}>Sprint Velocity</Text>
              <View style={{ flexDirection: 'row', flex: 1, alignContent: 'center', justifyContent: 'center' }}>
                <View style={{ width: 30, height: 8, backgroundColor: 'grey', marginTop: 15 }} />
                <Text style={{ padding: 10, }}>Committed</Text>
                <View style={{ width: 30, height: 8, backgroundColor: 'green', marginTop: 15 }} />
                <Text style={{ padding: 10, }}>Completed</Text>
              </View>
              <ScrollView horizontal={true} style={{ marginRight: 2, marginLeft: 2 }}>

                <PureChart data={sprintData} 
                   type='bar'
                  showEvenNumberXaxisLabel={false}
                  width={'100%'}
                  labelColor={'black'}
                  defaultColumnWidth={105}
                />


              </ScrollView>
            </View>

            

            {/* Individual Velocity */}
            <View style={{ flex: 1, marginTop: 10, marginBottom: 10 }}>
              <Text style={{ padding: 10, fontWeight: 'bold' }}>Individual Velocity</Text>

              <View style={{ paddingTop: 20, }}>
                <SearchableDropdown
                  placeholder={this.state.sprintName}
                  onTextChange={text => console.log(text)}
                  // onItemSelect={item => item.name}
                  // onItemSelect={(item) => this.setState({ assignedto: item.id })}
                  onItemSelect={(item) => { this.Network2(item.id), this.setState({ sprintName: item.name }) }}
                  // onItemSelect={(item) => { this.NetworkData(item.id) }}
                  placeholderTextColor='black'
                  containerStyle={{
                    paddingLeft: "2%",
                    width: '96%'

                  }}
                  placeholderTextColor='black'
                  textInputStyle={{
                    padding: 12,
                    borderWidth: 1,
                    borderColor: '#ccc',
                    backgroundColor: '#fff',
                    borderRadius: 20
                  }}
                  itemStyle={{
                    padding: 10,
                    marginTop: 2,
                    backgroundColor: '#FAF9F8',
                    borderColor: '#bbb',
                    borderWidth: 1,
                    borderRadius: 20
                  }}
                  itemTextStyle={{
                    color: '#222',
                  }}
                  items={this.state.resource1}
                  defaultIndex={2}
                  resetValue={false}
                  underlineColorAndroid="transparent"
                />
                <Text style={{ color: 'red' }}>{this.state.error3}</Text>
              </View>
              <View style={{ flexDirection: 'row', flex: 1, alignContent: 'center', justifyContent: 'center' }}>
                <View style={{ width: 30, height: 8, backgroundColor: 'grey', marginTop: 15 }} />
                <Text style={{ padding: 10, }}>Committed</Text>
                <View style={{ width: 30, height: 8, backgroundColor: 'green', marginTop: 15 }} />
                <Text style={{ padding: 10, }}>Completed</Text>
              </View>
              <ScrollView horizontal={true} style={{ marginRight: 2, marginLeft: 2 }}>
                <PureChart data={individualVelocity} type='bar'
                  width={'100%'}
                  height={200}
                  showEvenNumberXaxisLabel={false}
                  defaultColumnWidth={100}
                />

              </ScrollView>
            </View>


             {/* Epic Report */}
               <View style={{ flex: 1, marginTop: 10, marginBottom: 10 }}>
              <Text style={{ padding: 10, fontWeight: 'bold' }}>Epic Velocity</Text>

              <View style={{ paddingTop: 20, }}>
                <SearchableDropdown
                  placeholder={this.state.epicName}
                
                  onTextChange={text => console.log(text)}
                  // onItemSelect={item => item.name}
                  // onItemSelect={(item) => this.setState({ assignedto: item.id })}
                  onItemSelect={(item) => { this.NetworkEpic(item.id), this.setState({ epicName: item.name }) }}
                  // onItemSelect={(item) => { this.NetworkData(item.id) }}
                  placeholderTextColor='black'
                  containerStyle={{
                    paddingLeft: "2%",
                    width: '96%'

                  }}
                  placeholderTextColor='black'
                  textInputStyle={{
                    padding: 12,
                    borderWidth: 1,
                    borderColor: '#ccc',
                    backgroundColor: '#fff',
                    borderRadius: 20
                  }}
                  itemStyle={{
                    padding: 10,
                    marginTop: 2,
                    backgroundColor: '#FAF9F8',
                    borderColor: '#bbb',
                    borderWidth: 1,
                    borderRadius: 20
                  }}
                  itemTextStyle={{
                    color: '#222',
                  }}
                  items={this.state.resource2}
                  defaultIndex={2}
                  resetValue={false}
                  underlineColorAndroid="transparent"
                />
                <Text style={{ color: 'red' }}>{this.state.error3}</Text>
              </View>

              <View style={{ flexDirection: 'row', flex: 1, alignContent: 'center', justifyContent: 'center' }}>
                <View style={{ width: 30, height: 8, backgroundColor: 'grey', marginTop: 15 }} />
                <Text style={{ padding: 10, }}>Estimated</Text>
                <View style={{ width: 30, height: 8, backgroundColor: 'green', marginTop: 15 }} />
                <Text style={{ padding: 10, }}>Completed</Text>
              </View>
              <ScrollView horizontal={true} style={{ marginRight: 2, marginLeft: 2 }}>
                
                <PureChart 
                data={this.state.epicVelocity} 
                type={'line'}
                width={'100%'}
                height={200}
                // gap: 60,
                showEvenNumberXaxisLabel={false}
                 defaultColumnWidth={500}
              
                />

              </ScrollView>
              </View>

            {/* Burn Up Chart */}
            {/* <View style={{ flex: 1, marginTop: 10, marginBottom: 10 }}>
            <Text style={{ padding: 10, fontWeight: 'bold' }}>Burn Up Chart</Text>
            <ScrollView horizontal={true} style={{ marginRight: 10, marginLeft: 10 }}>

              <PureChart data={sprintBurnUpChart} type='bar'
                width={'100%'}
                height={200}
                showEvenNumberXaxisLabel={false}
              />
            
            </ScrollView>
          </View> */}
            {/* Individual Workload */}
            <View style={{ flex: 1, marginTop: 10, marginBottom: 10, width: '100%' }}>
              <Text style={{ padding: 10, fontWeight: 'bold' }}>Individual Workload</Text>

              <View style={{ paddingTop: 20, }}>
                <SearchableDropdown
                  placeholderTextColor='black'
                  placeholder={this.state.assignedName}
                  onTextChange={text => console.log(text)}
                  // onItemSelect={(item) => this.setState({ assignedto: item.id, assignedName: item.name })}
                  placeholderTextColor='black'
                  onItemSelect={(item) => { this.Network1(item.id), this.setState({ assignedName: item.name }) }}
                  containerStyle={{
                    paddingLeft: "2%",
                    width: '96%'

                  }}
                  textInputStyle={{
                    padding: 12,
                    borderWidth: 1,
                    borderColor: '#ccc',
                    backgroundColor: '#fff',
                    borderRadius: 20
                  }}
                  placeholderTextColor='black'
                  itemStyle={{
                    padding: 10,
                    marginTop: 2,
                    backgroundColor: '#FAF9F8',
                    borderColor: '#bbb',
                    borderWidth: 1,
                    borderRadius: 20
                  }}
                  itemTextStyle={{
                    color: '#222',
                  }}
                  items={this.state.resource}
                  defaultIndex={2}
                  resetValue={false}
                  underlineColorAndroid="transparent"
                />
                <Text style={{ color: 'red' }}>{this.state.error3}</Text>
              </View>
              <View style={{ flexDirection: 'row', flex: 1, alignContent: 'center', justifyContent: 'center' }}>
                <View style={{ width: 30, height: 8, backgroundColor: 'grey', marginTop: 15 }} />
                <Text style={{ padding: 10, }}>Committed</Text>
                <View style={{ width: 30, height: 8, backgroundColor: 'green', marginTop: 15 }} />
                <Text style={{ padding: 10, }}>Completed</Text>
              </View>
              <ScrollView horizontal={true} style={{ marginRight: 2, marginLeft: 2 }}>

                <PureChart data={individualWorkload} type='bar'
                  width={'100%'}
                  height={200}
                  showEvenNumberXaxisLabel={false}
                  defaultColumnWidth={100}
                />

              </ScrollView>
            </View>




          </Content>

        </Container>
      </KeyboardAvoidingView>
    );
  }
}

const styles = StyleSheet.create({
  submit: {
    flex: 1,
    ...Platform.select({
      ios: {
        color: 'white', paddingTop: 3, fontSize: 15, width: 100,
        height: 30, backgroundColor: '#00A2C1',
        textAlign: 'center', borderRadius: 10
      },
      android: {
        color: 'white', paddingTop: 3, fontSize: 15, width: 100,
        height: 30, backgroundColor: '#00A2C1',
        textAlign: 'center', borderRadius: 70
      },
    }),
  },
  mobile: {
    flex: 1,
    ...Platform.select({
      ios: {
        marginTop: 12
      },
      android: {

      },
    }),
  },
  role: {
    flex: 1,
    ...Platform.select({
      ios: {
        flexDirection: 'row', marginTop: 10
      },
      android: {
        flexDirection: 'row',
        paddingTop: 10,

      },
    }),
  },

});
const pickerSelectStyles = StyleSheet.create({
  inputIOS: {
    fontSize: 2,
    paddingVertical: 12,
    paddingHorizontal: 10,
    borderWidth: 1,
    borderColor: 'blue',
    borderRadius: 4,
    color: 'black',
    paddingRight: 30, // to ensure the text is never behind the icon
  },
  inputAndroid: {
    fontSize: 3,
    paddingHorizontal: 10,
    paddingVertical: 8,
    borderWidth: 0.5,
    borderColor: 'purple',
    borderRadius: 8,
    color: 'black',
    paddingRight: 30, // to ensure the text is never behind the icon
  },
});