/*
FileName:UserCompletedProjects.js
Version:1.0.0
Purpose:Getting the List of completed Projects list
Devloper:Raju,Naveen(Reopenproject)
*/
import React, { Component } from 'react';
import { Alert, Platform, StyleSheet, Text, View, TouchableOpacity, Picker, Dimensions, FlatList, TouchableHighlight, Image } from 'react-native';
import AsyncStorage from '@react-native-community/async-storage';
import { Title, Button, Container, Content, Header, Icon, Right, Left, Body, Tab, Tabs, TabHeading, Footer, Item, Input, FooterTab, Subtitle } from 'native-base';
// import Icon from 'react-native-vector-icons/FontAwesome';
import { widthPercentageToDP as wp, heightPercentageToDP as hp } from 'react-native-responsive-screen';
import { API } from "../WebServices/RestClient";
import NetInfo from '@react-native-community/netinfo';
import { NavigationEvents } from 'react-navigation';
import jwt_decode from "jwt-decode";
import Snackbar from 'react-native-snackbar';
import log from '../LogFile/Log';
import ModalSelector from 'react-native-modal-selector';
// import { Dropdown } from 'react-native-material-dropdown';
import DropDownPicker from 'react-native-dropdown-picker';
import UserDatabase from '../OfflineDB/UserDatabase';
const db = new UserDatabase();
import { COMPLETEDPROJECTS, PROJECTNO, TITLE, REQUESTED_BY, REOPEN } from '../CommonComponents/Header';

class ListItem extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            isLoading: true,
            roledata: '',
        }
        this.GetLevel();
    }

    //Get List Based o  Task Level
    GetLevel() {
        log("Info", "to get level no");
        AsyncStorage.getItem("levelno", (err, res) => {
            const level = res;
            AsyncStorage.getItem("emp_role", (err, res) => {
                const emprole = res;
                this.setState({
                    LevelId: level,
                    roledata: emprole
                });

            });
            //  alert(typeof(this.state.LevelId));
        });
    }
    //alert for project ReOpen
    ReOpenProjectAction() {
        log("Info", "ReOpenProject() method is used to give alert");
        const { item } = this.props;

        Alert.alert(
            'Alert..!',
            'Do you want to ReOpen the Project ?',
            [
                {
                    text: 'NO',
                    onPress: () => console.log('Cancel Pressed'),
                    style: 'NO',
                },
                { text: 'YES', onPress: () => this.ReOpenProject(item.idea_id) },
            ],
            { cancelable: false },
        );

    }


    //project verification 
    ReOpenProject(projectid) {
        log("Info", "ProjectReOpen(projectid) method is used to Re Open project");
        AsyncStorage.getItem("cropcode", (err, res) => {
            const cropcode = res;
            AsyncStorage.getItem("projectId", (err, res) => {
                const projectId = res;

                NetInfo.fetch().then(state => {
                    if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                        console.log(state.type);
                        Snackbar.show({
                            title: 'No Internet Connection',
                            backgroundColor: 'red',
                            duration: Snackbar.LENGTH_LONG,
                        });
                    } else {
                        fetch(API + 'manage_epics.php',
                            {
                                method: 'POST',
                                headers: {
                                    Accept: 'application/json',
                                    'Content-Type': 'application/json',
                                },
                                body: JSON.stringify({
                                    corp: cropcode,
                                    ideaId: projectid,
                                    action: 'reopen',
                                    projectId: projectId,
                                })
                            })
                            .then((response) => response.json())
                            .then((responseJson) => {
                                if (responseJson.status == 'True') {
                                    alert("Project Re Opened")
                                } else {
                                    alert(responseJson.message);
                                }
                            })
                            .catch((error) => {
                                console.error(error);
                                log("Error", "Project Reopen Error");
                            });
                    }
                });
            });
        });
    }

    render() {
        const { item } = this.props;
        AsyncStorage.getItem("emp_role", (err, res) => {
            this.setState({
                roledata: res
            })

        });
        let button;
        if (this.state.roledata == 'Approver' || this.state.roledata == 'Admin') {
            //  console.warn(this.state.roledata + "role");
            button = <TouchableOpacity style={{ width: 100, marginRight: 5 }} onPress={() => { this.MaintaskVerify() }}>
                <Text style={styles.signUpText02} >{item.completeStatus} </Text>
            </TouchableOpacity>
        } else {
            //  console.warn("HELLO"+this.state.roledata)
            button = <TouchableOpacity style={{ width: 100, marginRight: 5 }} >
                <Text style={styles.signUpText02} >{item.completeStatus} </Text>
            </TouchableOpacity>
        }
        return (
            <View style={styles.container}>
                {/* <TouchableOpacity onPress={this.props.Module}> */}
                <View style={styles.signup}>
                    <View style={[styles.buttonContainer, styles.signupButton]} >
                        <View style={styles.box}>

                            <View style={{ flexDirection: 'row' }}>
                                <Text style={styles.signUpText0} >{PROJECTNO}:</Text>
                                <Text style={styles.signUpText1} >{item.e_id}</Text>
                            </View>
                            <Text style={styles.signUpText2} >{item.created_on}</Text>
                        </View>
                        <View
                            style={{
                                borderBottomColor: '#C0C0C0',
                                borderBottomWidth: 0.3,
                            }}
                        />

                        <View style={{ flexDirection: 'row', paddingRight: 25, }}>
                            <View style={{ width: wp('70%'), flexDirection: 'row' }}>
                                <Text style={styles.signUpText4} >{TITLE}:</Text>
                                <Text style={styles.signUpText3} >{item.idea_title}</Text>
                            </View>
                            <View>
                                <TouchableOpacity style={{ width: 80, backgroundColor: '#6cbb3f', marginEnd: 100, marginTop: 15, marginRight: 10 }} onPress={() => { this.ReOpenProjectAction() }}>
                                    <Text style={{ color: '#fff', textAlign: 'center' }}>{REOPEN}</Text></TouchableOpacity>
                            </View>
                        </View>

                        <View style={{ flexDirection: 'row', paddingRight: 25 }}>
                            <Text style={styles.signUpText4} >{REQUESTED_BY}:</Text>
                            <Text style={styles.signUpText3} >{item.userName}</Text>
                        </View>

                    </View>

                </View>
                {/* </TouchableOpacity> */}
            </View>

        )
    }
}
export default class UserCompletedProjects extends Component {

    static navigationOptions = () => {
        return {
            tabBarOnPress({ navigation, defaultHandler }) {
                navigation.state.params.onTabFocus();
                defaultHandler();
                this.onRefresh();
            }
        };
    }
    constructor(props) {

        super(props);
        this.state = {
            isLoading: true,
            dataSource: [],
            dataSource1: [],
            isFetching: false,
            role: '',
            userToken: '',
            idea_id: '',
            empId: '',
            squadName: '',
        }
        AsyncStorage.getItem("cropcode", (err, res) => {
            this.setState({ squadName: res });
            console.warn("squadname" + this.state.squadName);
        });
        this.arrayholder = [];
    }

    handleTabFocus = () => {
        this.onRefresh();
    };
    //Refresh the List Of userCompletedProjects
    onRefresh() {
        NetInfo.fetch().then(state => {
            if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                console.log(state.type);
                Snackbar.show({
                    title: 'No Internet Connection',
                    backgroundColor: 'red',
                    duration: Snackbar.LENGTH_LONG,
                });
                this.getCompletedProjectsListOffline(); //Offline Getting Projects List
            } else {
                //to get the user Approved Project list
                this.userCompletedProjects(this.state.role, this.state.userToken, this.state.cropcode)
                this.GetStatus();

            }
        });
    }
    //Getting the Details Like role,usertoken and corpcode
    async componentDidMount() {
        log("Debug", "user completed projects screen is loaded");
        await AsyncStorage.getItem("emp_role", (err, res) => {
            console.log(res);
            this.setState({ role: res });
        });

        await AsyncStorage.getItem("userToken", (err, res) => {
            console.log(res);
            this.setState({ userToken: res });
        });
        await AsyncStorage.getItem("cropcode", (err, res) => {
            console.log(res);
            this.setState({ cropcode: res });
        });

        console.log(this.state.userToken);
        console.log(this.state.role);
        NetInfo.fetch().then(state => {
            if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                console.log(state.type);
                Snackbar.show({
                    title: 'No Internet Connection',
                    backgroundColor: 'red',
                    duration: Snackbar.LENGTH_LONG,
                });
                this.getCompletedProjectsListOffline() //Offline completed Projects List
                this.GetStatus();//offline getting projects
            } else {
                //to get the user Approved Project list
                this.userCompletedProjects(this.state.role, this.state.userToken, this.state.cropcode)
                this.GetStatus();
            }
        });
    }


    //get project list dropdown data
    GetStatus() {
        log("Info", "UserProfile:GetStatus() method is used to get status of employee");
        AsyncStorage.getItem("userToken", (err, res) => {
            const empId = res;
            NetInfo.fetch().then(state => {
                if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                    // console.log(state.type);
                    Snackbar.show({
                        title: 'No Internet Connection',
                        backgroundColor: 'red',
                        duration: Snackbar.LENGTH_LONG,
                    });
                    this.getAgileProjects(); //Get offline Project List
                } else {

                    fetch(API + 'squads.php', {
                        method: 'POST',
                        headers: {
                            Accept: 'application/json',
                            'Content-Type': 'application/json',
                        },
                        body: JSON.stringify({

                            empId: empId,
                            action: 'get_squads',


                        })
                    })
                        .then((response) => response.json())
                        .then((responseJson) => {
                            console.warn(responseJson)
                            if (responseJson.status == 'True') {
                                // this.setState({
                                //     isLoading: false,
                                //     dataSource1: [...responseJson.data],
                                // }, function () {
                                //     // In this block you can do something with new state.
                                // });
                                console.log("Testing" + JSON.stringify(responseJson.data))
                                const data2 = [];
                                this.addAgileProjects(responseJson.data) //Project list store in offline

                                responseJson.data.map(x => {
                                    data2.push({ label: x.value, value: x.value })
                                })
                                this.setState({
                                    data2: data2,
                                })
                                console.warn("Hello" + JSON.stringify(data2))

                                // this.setState({
                                //     data2: responseJson.data
                                // });
                                console.warn(this.state.data2);
                            } else {
                                log("Warn", "status of employee is not available");
                            }
                        })
                        .catch((error) => {
                            console.error(error);
                            log("Error", "error in  getting status of employee");
                        });
                }
            });
        });

    }

    // Update Status of Employee
    UpdateStatus(squadName) {
        // const { squadName } = this.state;
        log("Info", "UserProfile:UpdateStatus(status) method is used to update status of employee");
        console.warn("project" + JSON.stringify(squadName));


        AsyncStorage.getItem("userToken", (err, res) => {
            const empId = res;
            console.log(res);

            AsyncStorage.getItem("projectId", (err, res) => {
                const projectId = res;



                // console.log(cropcode);
                NetInfo.fetch().then(state => {
                    if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                        console.log(state.type);
                        Snackbar.show({
                            title: 'No Internet Connection',
                            backgroundColor: 'red',
                            duration: Snackbar.LENGTH_LONG,
                        });
                        //for offline project switching start
                        this.setState({
                            squadName: squadName
                        });
                        AsyncStorage.setItem('cropcode', squadName);
                        this.getCompletedProjectsListOffline()
                        //for offline project switching end
                    } else {

                        fetch(API + 'squad_login.php', {
                            method: 'POST',
                            headers: {
                                Accept: 'application/json',
                                'Content-Type': 'application/json',
                            },
                            body: JSON.stringify({
                                username: empId,
                                corp: squadName,
                                projectId: projectId

                            })
                        })
                            .then((response) => response.json())
                            .then((responseJson) => {
                                console.warn(JSON.stringify(responseJson))

                                if (responseJson.status == 'TRUE') {
                                    AsyncStorage.setItem('auth', responseJson.jwt) //store the token information  with exp
                                    const tokenDetails = jwt_decode(responseJson.jwt);
                                    console.log(tokenDetails.data)
                                    AsyncStorage.setItem('roleCount', tokenDetails.data.roleCount)
                                    // dispatch(setCurrentUser(tokenDetails.data)); //store the user information
                                    AsyncStorage.setItem('status', tokenDetails.data.empStatus)


                                    AsyncStorage.setItem('userToken', tokenDetails.data.empId);
                                    AsyncStorage.setItem('userName', tokenDetails.data.userName);
                                    AsyncStorage.setItem('emp_role', tokenDetails.data.role);
                                    AsyncStorage.setItem('cropcode', tokenDetails.data.corp);
                                    AsyncStorage.setItem('projectId', tokenDetails.data.projectId);

                                    // this.props.navigation.navigate('UserProfile');
                                    // console.warn("HI" + empstatus)
                                    this.setState({

                                        squadName: tokenDetails.data.corp,

                                    });

                                    this.userCompletedProjects(tokenDetails.data.role, tokenDetails.data.empId, tokenDetails.data.corp);
                                    //  alert("Project Changed Successfully")


                                } else {

                                    //    alert("user already exist");
                                    log("Warn", "status of employee is not able to update");
                                }

                            })
                            .catch((error) => {
                                console.warn(error);
                                log("Error", "error in updating status of employee");
                            });
                    }
                });
            });
        });

    }

    //For store Agile projects for offline Start
    addAgileProjects(data) {
        console.warn("hello naveen" + JSON.stringify(data));
        db.addAgileProjects(data).then((result) => {
            this.setState({
                isLoading: false,
            });
        }).catch((err) => {
            console.log(err);
            this.setState({
                isLoading: false,
            });
        })
    }
    //For store Agile projects for offline End
    //For Getting offline Project List Start
    getAgileProjects() {
        db.getAgileProjects().then((data) => {
            console.warn("AgileProjectsList" + JSON.stringify(data))
            this.setState({
                data2: data,
                isLoading: false,
            });
        }).catch((err) => {
            this.setState({
                isLoading: false,
            });
        })
    }
    //For Getting offline Project List End

    //For Approved Projects from offline
    getCompletedProjectsListOffline() {
        AsyncStorage.getItem("cropcode", (err, res) => {
            const projectName = res;
            db.getApprovedProjectsListOffline(projectName, "completed").then((data) => {
                console.warn("Approved ProjectList" + JSON.stringify(data))
                this.setState({
                    dataSource: data,
                    isLoading: false,
                });
                this.arrayholder = data;
            }).catch((err) => {
                console.log(err);
                this.setState = {
                    isLoading: false
                }
            })
        });
    }
    //For store Approved Projects list from offline
    addCompletedProjectsListOffline(data, cropcode, status) {
        db.addApprovedProjectsListOffline(data, cropcode, status).then((result) => {
            this.setState({
                isLoading: false,
            });
        }).catch((err) => {

            this.setState({
                isLoading: false,
            });
        });
    }

    //get AdminApprovedProjects list start
    userCompletedProjects(role, userToken, cropcode) {
        AsyncStorage.getItem("projectId", (err, res) => {
            const projectId = res;


            log("Info", "UserCompletedProjects:userCompletedProjects(role, userToken, cropcode) method used to get all completed projects at user side");
            //Checking the Internet Connection
            NetInfo.fetch().then(state => {
                if (state.type == "none" || state.type == 'unknown' || state.type == 'undefined') {
                    console.log(state.type);
                    Snackbar.show({
                        title: 'No Internet Connection',
                        backgroundColor: 'red',
                        duration: Snackbar.LENGTH_LONG,
                    });
                } else {
                    fetch(API + 'get_epics.php',
                        {
                            method: 'POST',
                            headers: {
                                Accept: 'application/json',
                                'Content-Type': 'application/json',
                            },
                            body: JSON.stringify({
                                corp: cropcode,
                                action: 'completed',
                                empId: userToken,
                                userType: role,
                                projectId: projectId
                                // empId:empId
                            })
                        })
                        .then((response) => response.json())
                        .then((responseJson) => {
                            // alert(JSON.stringify(responseJson));
                            console.log(responseJson)
                            if (responseJson.connection === 'connected ') {
                                if (responseJson.status === 'True') {
                                    // alert(JSON.stringify(responseJson.data))
                                    this.addCompletedProjectsListOffline(responseJson.data, cropcode, "completed"); //For Store Completed Project List in Offline
                                    this.setState({
                                        isLoading: false,
                                        dataSource: responseJson.data,
                                        isFetching: false
                                    }, function () {

                                    });
                                    this.arrayholder = responseJson.data;
                                }
                                else {
                                    log("Info", "no completed epics at user side");
                                    this.arrayholder = [];
                                    this.setState({
                                        isLoading: false,
                                        dataSource: [],
                                    })
                                    Snackbar.show({
                                        title: 'No Completed Epics',
                                        backgroundColor: '#3BB9FF',
                                        duration: Snackbar.LENGTH_LONG,
                                    });
                                }
                            }
                            else {
                                this.props.navigation.navigate('Maintenance');
                            }
                        })
                        .catch((error) => {
                            //console.error(error);
                            log("Error", "Error in getting completed projects at user side");
                        });
                }
            });
        });
    }
    //list seperator
    FlatListItemSeparator = () => {
        return (
            <View
                style={{
                    //  height: .5,
                    width: "100%",
                    backgroundColor: "#000",
                }}
            />
        );
    }
    //For Empty data
    _listEmptyComponent = () => {
        return (
            <View style={{ width: '90%', height: '80%' }}>
                <Text></Text>
            </View>
        )
    }
    //For Search 
    SearchFilterFunction(text) {
        log("Info", "UserCompletedProjects:SearchFilterFunction(text) method used for search functionality");
        console.log(text);
        const newData = this.arrayholder.filter(function (item) {
            const idea_id = item.idea_id.toUpperCase()
            const idea_id1 = text.toUpperCase()
            const idea_title = item.idea_title.toUpperCase()
            const idea_title1 = text.toUpperCase()
            const userName = item.userName.toUpperCase()
            const userName1 = text.toUpperCase()

            return idea_id.indexOf(idea_id1) > -1 ||
                idea_title.indexOf(idea_title1) > -1 ||
                userName.indexOf(userName1) > -1
        })
        this.setState({
            dataSource: newData,
            text: text
        })
    }
    render() {
        return (
            <Container style={{ height: Dimensions.get('window').height }}>


                <Header
                    androidStatusBarColor="#00A2C1"
                    style={{
                        backgroundColor: '#00A2C1',
                        height: 60,
                        width: Dimensions.get('window').width,
                        borderBottomColor: '#ffffff',
                        justifyContent: 'space-between',
                    }}>
                    <View style={{ marginTop: 20 }}>
                        <Icon name="md-menu" size={25} style={{ color: 'white', }} onPress={() =>
                            this.props.navigation.toggleDrawer()} />
                    </View>

                    {/* <View style={{backgroundColor:'white',width:200,borderRadius:20,paddingBottom:10}}>
                        
                        <Dropdown
           label={this.state.squadName}
            data={this.state.dataSource1}
            style={{width:200,marginBottom:10}}
            onChangeText={(itemValue) => { this.UpdateStatus(itemValue) }}
            value={this.state.squadName}
      
          />
          </View> */}
                    {/* <View style={{ flexDirection: 'row', marginLeft: 15 }}> */}
                    {/* <View style={{backgroundColor:'white',width:300,borderRadius:20,height:50,marginTop:5}}> */}
                    <View style={{ width: 300, borderRadius: 20, height: 45, marginTop: 5, flexDirection: 'row' }}>

                        <ModalSelector
                            style={{ width: 260, backgroundColor: 'transparent', borderColor: 'transparent', marginLeft: 60 }}
                            data={this.state.data2}
                            initValue={this.state.squadName}
                            optionContainerStyle={{ backgroundColor: 'white' }}
                            onChange={(itemValue) => { this.UpdateStatus(itemValue.label) }} >
                            <View style={{ width: 300, borderRadius: 20, backgroundColor: '#00A2C1', height: 45, flexDirection: 'row' }}>
                                <Text style={{ marginTop: 15, color: 'white', width: 80 }}>PROJECT : </Text>

                                <Text style={{ marginTop: 15, color: 'white', width: 120, }}>{this.state.squadName}</Text>

                                <Icon name="md-chevron-down-outline" size={25} style={{ color: 'white', marginTop: 10, }}
                                />
                            </View>

                        </ModalSelector>
                    </View>
                    {/* <DropDownPicker
                label={this.state.data2}
                items={this.state.data2}
                placeholder={this.state.squadName}
      
                onChangeItem={(itemValue) => { this.UpdateStatus(itemValue) }}
                value={this.state.squadName}
      
                containerStyle={{ height: 40, width: 300, paddingLeft: 10, marginTop: 10, marginLeft: 30 }}
                style={{ backgroundColor: '#fafafa' }}
                itemStyle={{
                  justifyContent: 'flex-start',
                  // height:'2%'
                }}
                // defaultValue={this.state.data2}
                dropDownStyle={{ backgroundColor: '#fafafa', height: 80 }}
      
              /> */}
                    {/* <Picker
                          
                           style={pickerSelectStyles.inputAndroid}
                              selectedValue={this.state.squadName}
                              // onChangeText={(itemValue) => { this.UpdateStatus(itemValue) }}
                              
      
                              // onValueChange={(itemValue, itemIndex) => this.setState({ squadName: itemValue })} >
      
                               onValueChange={(itemValue, itemIndex) => this.UpdateStatus(itemValue)} >
      
                              {this.state.dataSource1.map((item, key) => (
                                  <Picker.Item label={item.value} value={item.value} key={key} />)
                              )}
      
                          </Picker> */}
                </Header>
                <Item>
                    <NavigationEvents
                        onDidFocus={() => this.onRefresh()}
                    />
                    <Input placeholder="Search"
                        onChangeText={(text) => this.SearchFilterFunction(text)} />
                    <Icon size={25} name="search" />
                </Item>
                <Content>
                    <View>
                        <View>

                            <FlatList

                                extraData={this.state}
                                keyExtractor={this._keyExtractor}
                                renderItem={this._renderItem}

                                data={this.state.dataSource}

                                onRefresh={() => this.onRefresh()}
                                refreshing={this.state.isFetching}

                                ItemSeparatorComponent={this.FlatListItemSeparator}
                                renderItem={({ item, index }) =>
                                    <View>

                                        <ListItem navigation={this.props.navigation}
                                            item={item}
                                            ReOpenProjectAction={() => this.ReOpenProjectAction(item, index)}//For ReOpen Project
                                        />
                                    </View>
                                }
                                keyExtractor={item => item.id}
                                ListEmptyComponent={this._listEmptyComponent}
                            />

                        </View>
                    </View>
                </Content>



            </Container>
        );
    }
}
//Styles for UI
const styles = StyleSheet.create({
    container: {
        flex: 1,
        width: '90%',
        paddingLeft: hp('2%'),
    },
    footer: {
        position: 'absolute',
        flex: 0.1,
        left: 0,
        right: 0,
        bottom: -10,
        backgroundColor: 'green',
        flexDirection: 'row',
        height: 80,
        alignItems: 'center',
    },
    bottomButtons: {
        alignItems: 'center',
        justifyContent: 'center',
        flex: 1,
    },
    footerText: {
        color: 'white',
        fontWeight: 'bold',
        alignItems: 'center',
        fontSize: 18,
    },
    buttonContainer: {
        width: wp('90%'),
        alignSelf: 'baseline',
        marginBottom: 10,
        color: '#d2691e',
        marginLeft: 4,



    },
    signupButton: {

        backgroundColor: '#ffffff',
    },
    subcontainer: {
        flex: 2,
        flexDirection: 'row',
        paddingTop: 40
    },
    signUpText0: {
        fontSize: 13,
        color: 'green',
        paddingTop: 10,

    },
    signUpText1: {
        fontSize: 13,
        color: 'green',
        paddingTop: 10,

        paddingLeft: 10,
    },
    end: {

        alignItems: 'flex-end',

    },
    end1: {
        flex: 2,
        height: '50%',
        paddingTop: 20,
        justifyContent: 'space-between',

        flexDirection: 'row',
    },
    s: {
        justifyContent: 'center',

        backgroundColor: '#ed7070',
        shadowOffset: { width: 50, height: 50 },
        alignItems: 'center',
        width: wp('40%'),
        height: hp('12%'),

    },
    signUpText2: {
        fontSize: 13,
        marginLeft: 200,

        color: 'green',
        paddingTop: 10,
    },
    signUpText3: {

        fontSize: 13,
        paddingTop: 10,
        paddingLeft: 10,

        alignItems: 'center',
    },
    signUpText4: {
        fontSize: 13,
        paddingTop: 10,


        alignItems: 'center',
    },
    signup: {
        color: "#FFF",

    },
    boxone: {
        flex: 1,
        marginTop: 5,

    },
    boxtwo: {
        flex: 1,

    },
    boxthree: {
        flex: 1,

    },
    box: {
        flexDirection: 'row',
        position: 'relative',
        marginBottom: 10,


    },
    signUpText: {
        fontSize: 13,
        justifyContent: 'center',


        color: 'white',
        alignSelf: 'center',
    },
});


const pickerSelectStyles = StyleSheet.create({
    inputIOS: {
        fontSize: 2,
        paddingVertical: 12,
        paddingHorizontal: 10,
        borderWidth: 1,
        borderColor: 'blue',
        borderRadius: 4,
        color: 'black',
        paddingRight: 30, // to ensure the text is never behind the icon
    },
    inputAndroid: {
        fontSize: 3,
        paddingHorizontal: 10,
        paddingVertical: 8,
        borderWidth: 0.5,
        borderColor: 'black',
        borderRadius: 8,
        color: 'black',
        paddingRight: 30, // to ensure the text is never behind the icon
        // backgroundColor:'pink'
    },
});
